package ascolto;

import java.net.*;
import java.io.*;
import java.awt.*;
import interfacciagrafica.Client;
import comunicazione.*;
/**
Autore: Barbara Allori<BR>
Data inizio: 29/12/1999<BR>
Versione: 1.0<BR>
Questo thread si occupa della ricezione dei messaggi provenienti dal server di chat.
*/

public class ThreadAscolto extends Thread
{ 
	private Client myclient;
	private DatagramSocket socket=null;
	private DatagramPacket recpacket;
	private String msg=null;
	private int udp,porta;
		
	/**
	Il costruttore si preoccupa di aprire una connessione UDP verso il server di chat.
	*/
	public ThreadAscolto(Client c)
	{
		myclient=c;
		try
		{
			socket=new DatagramSocket();
			myclient.udp=socket.getLocalPort();
			System.out.println("(TA) Il thread di ascolto ha generato la porta "+myclient.udp);
		}
		catch (SocketException se)
		{
		}
	}
 	public void run()
	{
		while (socket != null)
		{
			recpacket=new DatagramPacket(new byte[512],512);
			try
			{
				socket.receive(recpacket);
				//System.out.println("(TA) Eseguita la receive");
				msg=new String(recpacket.getData());
				System.out.println("(TA) Ricevuto messaggio da server di chat "+msg);
			}
			catch (IOException ioe)
			{
			}
			//msg vale null se vengo sbloccata dalla receive perche` un altro processo ha fatto la close
			if(msg!=null)
			{
				GestoreMsg gm=new GestoreMsg();
				if(gm.getTipo(msg)) 
				{
					myclient.testo.append(gm.getMsg(msg));
					myclient.testo.append("\n");
				}
				else
				{
					//HO RICEVUTO UN MESSAGGIO DI SISTEMA CHE MI FORNISCE I NUOVI DATI DELLA COPIA
					System.out.println("(TA) Il thread di ascolto ha ricevuto un messaggio di sistema");
					InetAddress ind=null;
					try
					{
						System.out.println("(TA) Vado ad aggiornare l`indirizzo del server di copia");
						myclient.csc.setCopiaServer(ind.getByName(gm.getServer(msg)));
					}
					catch (UnknownHostException uhe)
					{
					}
					//System.out.println("(TA) Porta di copia= "+gm.getPorta(msg));
					System.out.println("(TA) Vado ad aggiornare la porta del server di copia= "+gm.stringToInt(gm.getPorta(msg)));
					myclient.csc.setCopiaPortaTcp(gm.stringToInt(gm.getPorta(msg)));
				}
			}
		}//fine while		
	}//fine metodo run()
/**
Questo metodo si occupa della distruzione del thread di ascolto.
Da usare quando l'utente esce dalla stanza.
*/
	public void destroy()
	{
		socket.close();
		socket=null;
		msg=null;
		System.out.println("(TA) Thread di ascolto ucciso!");
	}
}//fine classe

