package comunicazione;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;
import utilita.*;
import interfacciagrafica.Client;
/**
Autore: Barbara Allori<BR>
Data inizio: 27/12/1999<BR>
Versione: 1.0<BR>
Si occupa della connessione verso il name server.
*/

public class ConnectNS extends Thread
{
	private InetAddress serverp=null,servers=null;
 	private int portap,portas;	//portap=porta del name server primario portas=porta del name server secondario
	private Socket client=null;
	private Client myclient;

//Costruttore usato dalla classe Client
 public ConnectNS(Client c)
	{ 
		myclient=c;	
	  try
		{
			System.out.println("(CNS) Name server primario= "+CostantiAlt.NSP);
			serverp=InetAddress.getByName(CostantiAlt.NSP);
			System.out.println("(CNS) Name server primario= "+CostantiAlt.NSP);
			servers=InetAddress.getByName(CostantiAlt.NSS);
			System.out.println("(CNS) Porta di ascolto del NSP= "+CostantiAlt.NSPFORC);
		  portap=CostantiAlt.NSPFORC;	
  	  portas=CostantiAlt.NSSFORC;	
		}
	  catch 	(UnknownHostException uhe) 
	  {
			System.out.println("(CNS) UnknownHostException");
			System.out.println("(CNS) Scambio name server primario con name server secondario");
			setNameServerPrimario();
			setPortaPrimario();
	  }
	  System.out.println("(CNS) Name server primario: "+serverp);
	  System.out.println("(CNS) Cerco di stabilire una connessione con il NSP");
	  apriConnessione();
	}

/**
Restituisce l'indirizzo del name server primario.
Tale indirizzo servir per ottenere l'indirizzo del server di chat di partenza.
*/
 public InetAddress getNameServerPrimario()
	{ return serverp;}
/**
Aggiorna l'indirizzo del name server primario.
Usata in caso di recovery non fa altro che scambiare tra loro name server primario e name server secondario.
*/
 private void setNameServerPrimario()
	{
	  InetAddress temp;
		temp=serverp;
		serverp=servers;
		servers=temp;
	}
/**
Aggiorna la porta del name server primario.
Usato in caso di recovery non fa altro che scambiare tra loro la porta del primario con quella del secondario
*/
private void setPortaPrimario()
{
	int temp;
	temp=portap;
	portap=portas;
	portas=temp;
}
/**
Restituisce il numero di porta tcp del name server primario.
*/
private int getPortaPrimario()
{
	return portap;
}
/**
Crea la soket per gestire la connessione con il name server primario.
Ottiene dal name server primario l'indirizzo di un server di chat con cui lavorare.
In caso di errore si dovr provvedere allo scambio tra name server primario e name server secondario.
*/
public void apriConnessione()
{
	ObjectOutputStream out=null;
	ObjectInputStream in=null;	
	boolean ciclo=false;
	int i=0;
	do
	{
		while (!isConnected()&& i<CostantiAlt.NUMEROTENTATIVI) 
		{
			setNameServerPrimario();
			setPortaPrimario();
			System.out.println("(CNS) Ho scambiato i server primari");
			i++;
		}//fine del while
		try
		{
			System.out.println("(CNS) Vado ad acquisire i flussi");
			//Acquisisco il flusso di uscita su cui scrivo
			out=new ObjectOutputStream(client.getOutputStream());
	  	//Acquisisco il flusso di ingresso su cui leggo
			in=new ObjectInputStream(client.getInputStream());
			System.out.println("(CNS) Ho acquisito i flussi");
			//implemento op.1
			out.writeObject(CostantiCom.SCREQC);
			System.out.println("(CNS) Ho fatto richiesta server di chat");
			InetAddress ind=(InetAddress)in.readObject();
			System.out.println("(CNS) Ho ricevuto il SdC "+ind);
			myclient.csc.setServer(ind);
			out.close();
			in.close();
			client.close();
			ciclo=false;
		}
		catch (IOException ioe) 
		{
			ciclo=true;
			System.out.println("(CNS) Ricevuta eccezione di I/O");
			setNameServerPrimario();
			setPortaPrimario();
			System.out.println("(CNS) Ho scambiato i server primari");
			try
			{
				this.sleep(CostantiAlt.DELAYFORTENTATIVI);
			}
			catch (InterruptedException ie)
			{
			}
		}	
		catch (NullPointerException npe1)	 
		{
			ciclo=true;
		}
		catch (ClassNotFoundException cnfe) 
		{
		}	
	i++;
	}//fine del do
	while (ciclo && i<CostantiAlt.NUMEROTENTATIVI);
	if(i==CostantiAlt.NUMEROTENTATIVI) System.exit(0);
}//fine apriConnessione

/**
Testa se  possiblile connettersi al name server primario.
Restituisce true se riesce a creare la socket verso il name server primario.
*/
private boolean isConnected()
{
	try
		{
			//Apro una connessione con il server primario
			System.out.println("(CNS) Sto per creare una socket verso NSP "+getNameServerPrimario()+" su porta "+getPortaPrimario());
			client=new Socket(getNameServerPrimario(),getPortaPrimario());
			System.out.println("(CNS)...socket screata");
			return true;
		}
	catch (UnknownHostException uhe)
	{
		return false;
	}
	catch (IOException ioe)
	{
		return false;
	}
	catch (NullPointerException npe)
	{
		return false;
	}
}//fine metodo isConnected
}//fine classe

