package comunicazione;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;
import ascolto.*;
import interfacciagrafica.Client;
import utilita.*;

/**
Autore: Barbara Allori<BR>
Data inizio:27/12/1999<BR>
Versione:1.0<BR>
Si occupa della connessione verso il server di chat ottenuto dal name server.<BR>
*/

public class ConnectSC extends Thread
{ private InetAddress server,servercopia;
  private int porta,portacopia,myporta;//myporta  la porta udp di ascolto
	private ArrayList lista=new ArrayList();
	private Socket socketmsg=null;
	private ObjectOutputStream output;
	private ThreadAscolto ta;
	private Client myclient;

//Costruttore usato dalla classe ThreadAscolto
public ConnectSC()
	{}
//Costruttore usato dalla classe Client
public ConnectSC(Client c)
{
	myclient=c;
}
/**
Restituisce l'indirizzo del server di chat a cui collegarsi per lavorare.<BR>
*/
 public InetAddress getServer()
	{return server;}
/**
Aggiorna l'indirizzo del server di chat a cui collegarsi. Tale indirizzo e` fornito
dal name server primario.<BR>
*/
 protected void setServer(InetAddress ind)
	{
		server=ind;
		System.out.println("(CSC) Server di chat primario settato a: "+ind);
	}
/**
Restituisce l'indirizzo del server di chat che contiene la copia della stanza.
Questo indirizzo viene comunicato dal server di chat a cui il client e' collegato.
In caso di crollo del server di chat primario ci si deve collegare a questo server.<BR>
*/	
 public InetAddress getCopiaServer()
	{
		System.out.println("(CSC) Server di chat di copia= "+servercopia);
		return servercopia;
	}
/**
Aggiorna l'indirizzo del server di chat che contiene la copia della stanza.<BR>
*/		
 public void setCopiaServer(InetAddress ind)
	{
		servercopia=ind;
		System.out.println("(CSC) Server di chat di copia settato a: "+ind);
	}
/**
Restituisce la porta TCP cui inviare i messaggi al server di chat primario.<BR>
*/	
 public int getPortaTcp()
	{
		return porta;
	}
/**
Aggiorna la porta TCP cui inviare i messaggi.<BR>
Questa informazione viene fornita dal server di chat a cui si chiede di creare/entrare stana.
*/	
 private void setPortaTcp(int port)
	{
		porta=port;
	}
/**
Restituisce la porta TCP del server di copia a cui inviare messaggi.<BR>
Si deve usare nel caso in cui ci siano problemi nella connessione con il
server di chat primario.
*/
 public int getCopiaPortaTcp()
	{return portacopia;}
/**
Aggiorna la porta TCP del server di copia a cui inviare messaggi in caso di errori.<BR>
Questa informazione viene fornita dal server di chat a cui si chiede di creare/entrare stana.
*/	
 public void setCopiaPortaTcp(int cport)
	{
		portacopia=cport;
	}
/**
Invia il messaggio msg dell'utente nomeutente al server di chat corrente.<BR>
*/
public void inviaMsg(String msg,String utente)
	{
		ArrayList socket_list=new ArrayList();
		try
		{
			output.writeObject(utente.concat(">").concat(msg));
			System.out.println("(CSC) Inviato messaggio utente= "+msg+" a server di chat "+getServer());
		}
		catch (IOException ioe)
		{
			/*try
			{
				this.sleep(1000);
			}
			catch (InterruptedException ie)
			{
			}
*/
			System.out.println("(CSC) E' caduto il serve di chat primario->mi sposto sul secondario");
			//devo spostarmi sul server di copia
			//E' caduto il server di chat->vado dalla copia
			setServer(getCopiaServer());
			setPortaTcp(getCopiaPortaTcp());
			//Ora il server di chat secondario  diventato il primario
			setCopiaServer(null);
			setCopiaPortaTcp(0);
			//Ora non ho pi un server di chat secondario perch coincide con il primario
			//In futuro mi verr comunicato il nuovo server di copia
			//Ora devo registrarmi al server di chat di copia
			socket_list=apriSocketMsg(utente);
			//e inviare il messaggio
			output=(ObjectOutputStream)socket_list.get(0);
			socketmsg=(Socket)socket_list.get(1);
			try
			{
				output.writeObject(utente.concat(">").concat(msg));
			        System.out.println("(CSC) Inviato messaggio utente= "+msg+" a server di chat "+getServer());
			}
			catch (IOException ioe1)
			{
				//Secondo la nostra ipotesi di guasto singolo qui non ci arrivo mai
				System.out.println("(CSC) Violata ipotesi di guasto singolo->esco dal sistema");
				System.exit(-1);
			}
		}//fine catch ie
	}//fine metodo inviaMsg
/**Restituisce l'elenco delle stanze presenti nel server di chat corrente.<BR>*/
 public ArrayList getListaStanze()
	{
		setListaStanze();
		return lista;
	}
private void setListaStanze()
	{
		Socket client=null;
	  ObjectOutputStream out=null;
		ObjectInputStream in=null;
		Integer temp;
		boolean ciclo=false;
		lista=new ArrayList();
		do
		{
			client=apriConnessione();
			try
			{
				//Acquisisco il flusso di uscita su cui scrivo
				out=new ObjectOutputStream(client.getOutputStream());
				//Acquisisco il flusso di ingresso su cui leggo
				in=new ObjectInputStream(client.getInputStream());
				//implemento op.2
				System.out.println("(CSC) Invio richiesta lista stanze a server di chat..");
				out.writeObject(CostantiCom.ROOMREQC);
				System.out.println("(CSC) Leggo lunghezza lista stanze...");
				temp=(Integer)in.readObject();
				int n=temp.intValue();
				System.out.println("(CSC) ..lunghezza lista= "+n);
				if(n > 0)
					for(int i=1;i<=n;i++)
					{
						lista.add((String)in.readObject());
					}
					System.out.println("(CSC) Ricevo questa lista stanze "+lista);
				//se n=-1 si pu uscire dal sistema
				//else 
					//if(n==-1)System.exit(0);
				out.close();
				in.close();
				client.close();
				ciclo=false;
			}
			catch (IOException ioe) 
			{
				ciclo=true;
			}
			catch (NullPointerException npe) 
			{
				ciclo=true;
			}
			catch (ClassNotFoundException cnfe)
			{
			}
		}
		while (ciclo);
	}//fine metodo setListaStanza					 
/**Invia al server di chat il nome della stanza cui accedere o creare.
*/
public void inviaStanza(String stanza,String utente)
{ 
	Socket client=null;
	ObjectOutputStream out=null;
	ObjectInputStream in=null;
	ArrayList socket_list=new ArrayList();
	Integer temp;
	String risp;
	boolean ciclo=false;
	ta=new ThreadAscolto(myclient);
	System.out.println("(CSC) Porta di ascolto di utente "+utente+"= "+myclient.udp);
	do
	{
	 	client=apriConnessione();
		try
		{
			System.out.println("(CSC) Acquisisco il flusso di uscita");
			//Acquisisco il flusso di uscita su cui scrivo
			out=new ObjectOutputStream(client.getOutputStream());
			System.out.println("(CSC) Acquisisco il flusso di ingresso");
			//Acquisisco il flusso di ingresso su cui leggo
			in=new ObjectInputStream(client.getInputStream());
			System.out.println("(CSC) Invio richiesta creazione stanza");
			//implemento op.3 e 4
			out.writeObject(CostantiCom.ROOMACCC);
			out.writeObject(stanza);
			out.writeObject(utente);
			out.writeObject(new Integer(myclient.udp));
			System.out.println("(CSC) Inviate info per creazione stanza");
			risp=(String)in.readObject();
			System.out.println("(CSC) Ricevuto: "+risp);
			if(risp.equals(CostantiCom.FAIL)) 
			{
				ciclo=true;
				//con ciclo=false funzionava
				//ciclo=false;//condizione temporanea
				System.out.println("(CSC) Impossibile creare la stanza");
			}
			else
			{
				setServer((InetAddress)in.readObject());
				temp=(Integer)in.readObject();
				setPortaTcp(temp.intValue());
				setCopiaServer((InetAddress)in.readObject());
				temp=(Integer)in.readObject();
				setCopiaPortaTcp(temp.intValue());
				out.close();
				in.close();
				client.close();
				ciclo=false;
			}
		}	
		catch (IOException ioe) 
		{
			ciclo=true;
		}
		catch (NullPointerException npe) 
		{
			ciclo=true;
		}
		catch (ClassNotFoundException cnfe) 
		{
		}
	}//fine do
	while (ciclo);
	//prima di uscire devo fare subito la connect sulla porta a cui invier i msg
	//implemento op.14
	socket_list=apriSocketMsg(utente);
	output=(ObjectOutputStream)socket_list.get(0);
	socketmsg=(Socket)socket_list.get(1);
	System.out.println("(CSC) Lancio il thread di ascolto");
	//Lancio il thread che ascolta i msg
	ta.start();
}//fine inviaStanza
/**
Chiude la socket con cui si inviavano i messaggi verso il server di chat.
Distrugge anche il thread di ascolto.
*/
public void esci()
	{
		try
		{
		  ta.destroy();
			output.close();
			socketmsg.close();
		}
		catch (IOException ioe)
		{
		}
	}
/**
Crea la socket per gestire la connessione con il server di chat corrente.
Per la comunicazione si usa la porta di default.
In caso di errore si dovr ottenere dal name server primario un nuovo server di chat.
*/
 private Socket apriConnessione()
	{ Socket client=null;
		boolean ciclo=false;
		int i=0;
		do
		{
			try
			{
				System.out.println("(CSC) Apro connessione con Server di chat..."+server);
				//Apro una connessione con il server di chat sulla porta di default
				client=new Socket(server,myclient.portadefault);
				System.out.println("(CSC) ..Connessione stabilita con "+getServer());
				ciclo=false;
			}
			catch (UnknownHostException uhe)
			{ 
				System.out.println("(CSC) E' caduto il server di chat->devo farmi dare un altro indirizzo dal name server");
				//E' caduto il server di chat->devo farmi dare un altro indirizzo dal name server
				ConnectNS cns=new ConnectNS(myclient);
				System.out.println("(CSC) Ho ottenuto un nuovo server di chat: "+getServer());
				//Ora che ho un nuovo indirizzo ripeto la connessione
				ciclo=true;
			}
			catch (IOException ioe)
			{
				System.out.println("(CSC) E' caduto il server di chat->devo farmi dare un altro indirizzo dal name server");
				//E' caduto il server di chat->devo farmi dare un altro indirizzo dal name server
				ConnectNS cns=new ConnectNS(myclient);
				System.out.println("(CSC) Ho ottenuto un nuovo server di chat: "+getServer());
				//Ora che ho un nuovo indirizzo ripeto la connessione
				ciclo=true;
			}
			//Ha senso catturare questa eccezione solo per le prove sulla stessa macchina
			catch (NullPointerException npe)
			{ //E' caduto il server di chat->devo farmi dare un altro indirizzo dal name server
				ConnectNS cns=new ConnectNS(myclient);
				//Ora che ho un nuovo indirizzo ripeto la connessione
				ciclo=true;
			}
			i++;
		}
		while (ciclo && i<CostantiAlt.NUMEROTENTATIVI);
		if(i==CostantiAlt.NUMEROTENTATIVI) System.exit(0);
		return client;
	}//fine apriConnessione()
/**
Apre la socket per inviare messaggi utente al server di chat.
Registra l'utente utente presso il server di chat.
Ritorna la socket con cui comunicare e il flusso d'uscita.
*/
private ArrayList apriSocketMsg(String utente)
	{
		Socket socketmsg=null;
		ObjectOutputStream out=null;
		ArrayList socket_structure=new ArrayList();
		boolean eccezione=false;
		try
		{
			System.out.println("(CSC) Apro la socket per inviare msg al server di chat "+getServer()+" su porta " +getPortaTcp());
			//Apro la socket che mi serve per inviare msg al server di chat
			socketmsg=new Socket(getServer(),getPortaTcp());
			System.out.println("(CSC) Connessione stabilita con: "+getServer());
		}
		catch (UnknownHostException uhe)
		{
			eccezione=true;
			System.out.println("(CSC) E' caduto il server di chat->vado dalla copia");
			//E' caduto il server di chat->vado dalla copia
			setServer(getCopiaServer());
			setPortaTcp(getCopiaPortaTcp());
			//Ora il server di chat secondario  diventato il primario
			setCopiaServer(null);
			setCopiaPortaTcp(0);
			//Ora non ho pi un server di chat secondario perch coincide con il primario
			//In futuro mi verr comunicato il nuovo server di copia
			try
			{
				//Apro la socket che mi serve per inviare msg al server di chat di copia
				System.out.println("(CSC) Riprovo dopo che ho scambiato i server di chat");
				socketmsg=new Socket(getServer(),getPortaTcp());
			}
			//per l'ipotesi di guasto singolo non ho bisogno di gestire queste eccezioni
			catch (UnknownHostException uhe1)
			{
			}
			catch (IOException ioe1)
			{
			}
			catch (NullPointerException npe1)
			{
			}
		}//fine catch UnknownHostException
		catch (IOException ioe)
		{
		}
		catch (NullPointerException npe)
		{
			eccezione=true;
			//E' caduto il server di chat->vado dalla copia
			setServer(getCopiaServer());
			setPortaTcp(getCopiaPortaTcp());
			//Ora il server di chat secondario  diventato il primario
			setCopiaServer(null);
			setCopiaPortaTcp(0);
			//Ora non ho pi un server di chat secondario perch coincide con il primario
			//In futuro mi verr comunicato il nuovo server di copia
			try
			{
				//Apro la socket che mi serve per inviare msg al server di chat di copia
				System.out.println("(CSC) Riprovo dopo che ho scambiato i server di chat");
				socketmsg=new Socket(getServer(),getPortaTcp());
			}
			catch (UnknownHostException uhe2)
			{
			}
			catch (IOException ioe2)
			{
			}
			catch (NullPointerException npe2)
			{
			}
		}//fine catch NullPointerException
		try
		{
			System.out.println("(CSC) Attendo flusso di uscita...");
			out=new ObjectOutputStream(socketmsg.getOutputStream());
			System.out.println("(CSC) ...flusso di uscita ottenuto");
			System.out.println("(CSC) Invio nome utente= "+utente);
			out.writeObject(utente);
		}
		catch (IOException ioe3)
		{
			if(!eccezione)
			{
		  	System.out.println("(CSC) E' caduto il server di chat->vado dalla copia");
				//E' caduto il server di chat->vado dalla copia
				setServer(getCopiaServer());
				setPortaTcp(getCopiaPortaTcp());
				//Ora il server di chat secondario  diventato il primario
				setCopiaServer(null);
				setCopiaPortaTcp(0);
			//Ora non ho pi un server di chat secondario perch coincide con il primario
			//In futuro mi verr comunicato il nuovo server di copia
				try
				{
				  System.out.println("(CSC) Riprovo dopo che ho scambiato i server di chat");
					//Apro la socket che mi serve per inviare msg al server di chat di copia
					socketmsg=new Socket(getServer(),getPortaTcp());
				}
				catch (UnknownHostException uhe4)
				{
				}
				catch (IOException ioe4)
				{
				}
				catch (NullPointerException npe4)
				{
				}
			}
		}
		catch (NullPointerException npe3)
		{
			if(!eccezione)
			{
			  System.out.println("(CSC) E' caduto il server di chat->vado dalla copia");
				//E' caduto il server di chat->vado dalla copia
				setServer(getCopiaServer());
				setPortaTcp(getCopiaPortaTcp());
				//Ora il server di chat secondario  diventato il primario
				setCopiaServer(null);
				setCopiaPortaTcp(0);
			//Ora non ho pi un server di chat secondario perch coincide con il primario
			//In futuro mi verr comunicato il nuovo server di copia
				try
				{	System.out.println("(CSC) Riprovo dopo che ho scambiato i server di chat");
					//Apro la socket che mi serve per inviare msg al server di chat di copia
					socketmsg=new Socket(getServer(),getPortaTcp());
				}
				catch (UnknownHostException uhe4)
				{
				}
				catch (IOException ioe4)
				{
				}
				catch (NullPointerException npe4)
				{
				}
			}//fine if
		}//fine catch NullPointerException
		socket_structure.add(out);
		socket_structure.add(socketmsg);
		return socket_structure;
	}
}//fine classe

