/**
Autore Renato Ricci <BR>
26-08-00 <BR>
Versione Beta <BR>
*/

package main_ns;

import java.lang.*;
import java.net.*;
import java.util.*;

import dati_ns.*;
import utility_ns.*;

/**
Classe che si occupa dell'avvio del Name Server. <BR>
*/

public class MainClass
  {
	/**Contiene i Server di Chat registrati*/
	public static TabellaServerDiChat tabsdc=null; 
	
	/**Contiene l'info sullo stato di esecuzione del Name Server (primario o no)*/
	public static FlagPrimario primario=null;
	
	/**Porta di ascolto cui si connette il Client*/
	public static int portaclient=0;
	
	/**Porta di ascolto cui si connette il Server di Chat*/
	public static int portaserverdichat=0;
	
	/**Porta di ascolto cui si connette l'altro Name Server*/
	public static int portanameserver=0;
	
	/**Porta di ascolto dell'altro Name Server per il Name Server*/
	public static int portaaltronameserver=0;
	
	/**Indirizzo dell'altro Name Server*/
	public static String indnome=null;
	
	/**Oggetto per la generazione di numeri casuali*/
	public static Random random;

	
	private static MainClass mainclass;
	private static ClientListener cl=null;
	private static ServerDiChatListener sdcl=null;
  private static NameServerListener nsl=null;
	

	public static void main(String[] args)
    {
		// args[0]=Porta Ascolto Client
	  // args[1]=Porta Ascolto Server di Chat
	  // args[2]=Porta Ascolto Name Server
		// args[3]=Porta Ascolto altro Name Server
		// args[4]=Indirizzo altro Name Server
	  try
		  {
			random=new Random();
		  portaclient=stringToInt(args[0]);
			System.out.println("Porta ascolto Client="+portaclient);
		  portaserverdichat=stringToInt(args[1]);
			System.out.println("Porta ascolto Server di Chat="+portaserverdichat);
		  portanameserver=stringToInt(args[2]);
			System.out.println("Porta ascolto Name Server="+portanameserver);
			portaaltronameserver=stringToInt(args[3]);
			System.out.println("Porta per connessione ad altro Name Server="+portaaltronameserver);
			indnome=args[4];
			System.out.println("Indirizzo altro Name Server="+InetAddress.getByName(indnome));
		  if ((portaclient>=1024)&&(portaclient<=65535)&&
			    (portaserverdichat>=1024)&&(portaserverdichat<=65535)&&
					(portanameserver>=1024)&&(portanameserver<=65535)&&
					(portaaltronameserver>=1024)&&(portaaltronameserver<=65535))
		  // nel test si contempla anche il caso in cui la stringa introdotta non sia numerica
	      {
			  tabsdc=new TabellaServerDiChat(mainclass);
		   	primario=new FlagPrimario(mainclass);
				if (primario.verificaCaduta())
				  System.out.println("Name Server primario in esecuzione...");
				else
				  {
				  System.out.println("Name Server Secondario in esecuzione...");
					System.out.println("Allineamento dati con Name Server Primario");
					while (!primario.recovery())
				    System.out.println("Allineamento fallito, ritento...");
					}
				// Si avviano i Listener
				cl=new ClientListener(mainclass,portaclient);
	      sdcl=new ServerDiChatListener(mainclass,portaserverdichat);
        nsl=new NameServerListener(mainclass,portanameserver);
			  cl.start();
	      sdcl.start();
	      nsl.start();
			  }
		  else
		    {
				System.out.println("Gli argomenti sono errati!");
			  System.out.println("Devi inserire in ordine:");
			  System.out.println("PORTA_CLIENT: intero compreso tra 1024 e 65535");
			  System.out.println("PORTA_SERVER_DI_CHAT: intero compreso tra 1024 e 65535");
			  System.out.println("PORTA_NAME_SERVER: intero compreso tra 1024 e 65535");
			  System.out.println("PORTA_ALTRO_NAME_SERVER: intero compreso tra 1024 e 65535");
				System.out.println("INDIRIZZO_ALTRO_NAME_SERVER: stringa indirizzo");
			  }
			}	
		catch (ArrayIndexOutOfBoundsException aioobe2)
		  {
			System.out.println("Il numero degli argomenti  errato!");
		  System.out.println("Devi inserire in ordine:");
		  System.out.println("PORTA_CLIENT: intero compreso tra 1024 e 65535");
		  System.out.println("PORTA_SERVER_DI_CHAT: intero compreso tra 1024 e 65535");
		  System.out.println("PORTA_NAME_SERVER: intero compreso tra 1024 e 65535");
		  System.out.println("PORTA_ALTRO_NAME_SERVER: intero compreso tra 1024 e 65535");
			System.out.println("INDIRIZZO_ALTRO_NAME_SERVER: stringa indirizzo");
			}
		catch (UnknownHostException uhe1)
		  {
			System.out.println("Indirizzo altro Name Server sconosciuto");
			}
		}
		
	 
	/**
	Converte una stringa in un numero intero. <BR>
	Lavora prendendo un carattere alla volta e 
	convertendolo in intero secondo il giusto peso. <BR>
	*/
  private static int stringToInt(String stringa)
    {
	  int lung=stringa.length();
	  int acc=0,num;
	  for (int i=0;i<lung;i++)
	    {
		  if((num=Character.digit(stringa.charAt(i),10))>=0)
		    {
			  for (int j=0;j<lung-i-1;j++)
			    {
				  num*=10;
			  	}
			  acc+=num;
			  }
		  else
		    {
			  acc=-1; // indica errore
			  i=lung; // forzo l'uscita dal for
			  }
		  }
	  return acc;			
    }

}  // fine classe

