/**
Autore Renato Ricci <BR>
25-08-00 <BR>
Versione Beta <BR>
*/

package utility_ns;

import main_ns.*;

import java.io.*;
import java.net.*;
import java.util.*;

/**
Classe che si occupa della gestione dell'accettazione di richieste dei Client. <BR>
*/
public class ClientListener extends Thread
  {	
	private ServerSocket serversocket=null;
	private Socket socketclient=null;
	private ClientReplier cr;
	private MainClass mainclass;
	
	/**
	Costruttore: crea la ServerSocket. <BR>
	*/
  public ClientListener(MainClass mc,int portaclient)
	  {
		try
		  {
			mainclass=mc;
		  serversocket=new ServerSocket(portaclient);
			System.out.println("Client List costr: creazione socket riuscita");
			}
		catch (IOException e1)
		  {
			System.out.println("Client List costr: creazione socket non riuscita");
			}
		}
		
	/**
	Thread che cicla infinitamente, fino a fallimento della socket,
	in attesa di una richiesta da un client. <BR>
	In coincidenza della richiesta fa partire il Thread Client Replier. <BR>
	*/
	public void run()
	  {
		System.out.println("Client Listener in esecuzione...");
	  boolean cicla=true;
		while (cicla)
		  {
		  try
			  {
				System.out.println("Client List: Accept...");
				socketclient=serversocket.accept();				
				System.out.println("Client List: Accept eseguita");
				// Parte il Client Replier
				cr=new ClientReplier(mainclass,socketclient);
				cr.start();
				}
			catch (IOException ioe1)
			  {
				try
				  {
					cicla=false;
				  System.out.println("Client List: socket fallita");
				  socketclient.close(); // socket fallita
					}
				catch (IOException ioe2)
				  {
					System.out.println("Client List: Chiusura socket fallita");
					}
				catch (NullPointerException npe1)
				  {
					System.out.println("Client List: socket inesistente, chiusura fallita");
					}
				}
			catch (NullPointerException npe2)
			  {
				cicla=false;
				System.out.println("Client List: socket inesistente");
				}
		  }
		}	
				
  }  // fine classe

