/**
Autore Renato Ricci <BR>
25-08-00 <BR>
Versione Beta <BR> 
*/

package utility_ns;

import main_ns.*;
import dati_ns.*;

import java.io.*;
import java.net.*;
import java.util.*;

/**
Classe che si occupa della gestione dell'accettazione di richieste
dell'altro Name Server. <BR>
*/
public class NameServerListener extends Thread
  {
	private ServerSocket serversocket=null;
	private Socket socketnameserver=null;
	private NameServerReplier nsr;
	private MainClass mainclass;
	
	/**
	Costruttore: crea la ServerSocket. <BR>
	*/
  public NameServerListener(MainClass mc,int portanameserver)
	  {
		try
		  {
			mainclass=mc;
		  serversocket=new ServerSocket(portanameserver);
			System.out.println("Name Serv List costr: creazione socket riuscita");
			}
		catch (IOException ioe1)
		  {
			System.out.println("Name Serv List costr: creazione socket non riuscita");
			}
		}
			
	/**
	Thread che cicla infinitamente, fino a fallimento della socket,
	in attesa di una richiesta dell'altro Name Server. <BR>
	In coincidenza della richiesta fa partire il Thread Name Server Replier. <BR>
	*/
	public void run()
	  {
		System.out.println("Name Server Listener in esecuzione...");
		boolean cicla=true;
		while (cicla)
		  {
		  try
			  {
				System.out.println("Name Serv List: Accept...");
				socketnameserver=serversocket.accept();
				System.out.println("Name Serv List: Accept eseguita");
			  nsr=new NameServerReplier(mainclass,socketnameserver);
				nsr.start();
				}
			catch (IOException ioe1)
			  {
				try
				  {
					cicla=false;
				  System.out.println("Name Server List: Socket fallita");
				  socketnameserver.close(); // socket fallita
					}
				catch (IOException ioe2)
				  {
					System.out.println("Name Server List: Chiusura socket fallita");
					}
				catch (NullPointerException npe1)
				  {
					System.out.println("Name Server List: socket inesistente, chiusura fallita");
					}
				}
			catch (NullPointerException npe2)
			  {
				cicla=false;
				System.out.println("Name Server List: socket inesistente");
				}
		  }
		}	
				
  }  // fine classe

