/**
Autore Renato Ricci <BR>
27-08-00 <BR>
Versione Beta <BR>
*/

package utility_ns;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.String;

import dati_ns.*;
import main_ns.*;

/**
Classe che si occupa del riconoscimento di una richiesta dell'altro Name Server,
della elaborazione e della generazione della risposta. <BR>
*/
public class NameServerReplier extends Thread
  {
	private Socket socket=null;
  private ObjectInputStream in=null;
  private ObjectOutputStream out=null;
  private MainClass mainclass;
  


  /**
	Costruttore: inizializza i flussi di ingresso e uscita verso
	l'altro Name Server. <BR>
	*/
  public NameServerReplier(MainClass mc,Socket s)
	  {
		try
		  {
			mainclass=mc;
			socket=s;
			in=new ObjectInputStream(socket.getInputStream());
			System.out.println("Name Serv Repl costr: creato flusso di ingresso...");
	    out=new ObjectOutputStream(socket.getOutputStream());   
			System.out.println("Name Serv Repl costr: creato flusso di uscita...");		  }
		catch (IOException ioe1)
		  {
			try
			  {
				System.out.println("Name Serv Repl costr: socket fallita");
				in.close();
				System.out.println("Name Serv Repl costr: chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("Name Serv Repl costr: chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("Name Serv Repl costr: chiusura socket riuscita");
				}
			catch (IOException ioe2)
			  {
				System.out.println("Name Serv Repl costr: chiusura socket non riuscita");
				}
			catch (NullPointerException npe1)
			  {
				System.out.println("Name Serv Repl costr: socket inesistente, chiusura non riuscita");
				}
			}
		catch (NullPointerException npe2)
		  {
			System.out.println("Name Serv Repl costr: socket inesistente");
			}
		catch (ArrayIndexOutOfBoundsException aioobe)
		  {
			try
			  {
	  		System.out.println("Name Serv Repl costr: accesso all'array errato");
				in.close();
				System.out.println("Name Serv Repl costr: chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("Name Serv Repl costr: chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("Name Serv Repl costr: chiusura socket riuscita");
				}
			catch (IOException io3)
			  {
				System.out.println("Name Serv Repl costr: chiusura socket non riuscita");
				}
			catch (NullPointerException npe3)
			  {
				System.out.println("Name Serv Repl costr: socket inesistente, chiusura non riuscita");
				}
			}
		}
		
	/**
	Thread che riceve la richiesta dell'altro Name Server, legge il tipo
	di richiesta e invoca il metodo che risponde a tale richiesta. <BR>
	Nel caso di richiesta di Tabella dei Server di Chat, setta a Primario
	il Name Server se gi non lo era. <BR>
	*/
	public void run()
	  {
		try
		  {
			
			System.out.println("Name Serv Repl: in esecuzione...");
			String str=(String)in.readObject();
			System.out.println("Name Serv Repl: ricevuta richiesta da NS");
		  if ((str.equals("TABLEREQ"))||(str.equals("SCREGN"))||(str.equals("SCDRGN")))
			  {
  			if (str.equals("TABLEREQ"))
		      {
					if (!mainclass.primario.getFlag())
	         	mainclass.primario.setFlag();
						// Il Name Server diventa Primario nel caso in cui nessuno si fosse accorto
						// che il Name Server che sta facendo recovery ed era primario era caduto
		      System.out.println("NS1: ricevuta richiesta tabella da NS2");
			  	generatoreTabella();              
          }
			  if (str.equals("SCREGN"))
				  {
					System.out.println("NS2: ricevuta richiesta registrazione SDC da NS1");
			    registrazioneSDCsuNS2();
					}
			  if (str.equals("SCDRGN"))
				  {
					System.out.println("NS2: ricevuta richiesta deregistrazione SDC da NS1");
				  deregistrazioneSDCsuNS2();
					}
				}
			else
			  {
				if (mainclass.primario.getFlag())
			    System.out.println("NS1: richiesta da NS2 non corretta");
				else
			    System.out.println("NS2: richiesta da NS1 non corretta");		
				}
			}
		catch (IOException ioe1)
		  {
			try
			  {
				System.out.println("Name Serv Repl: socket fallita");
				in.close();
		  	System.out.println("Name Serv Repl: chiusura flusso di ingresso riuscita");
				out.close();
		  	System.out.println("Name Serv Repl: chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("Name Serv Repl: chiusura socket riuscita");
				}
			catch (IOException ioe2)
			  {
				System.out.println("Name Serv Repl: chiusura socket non riuscita");
				}
			catch (NullPointerException npe1)
			  {
				System.out.println("Name Serv Repl: socket inesistente, chiusura non riuscita");
				}
			}
		catch (NullPointerException npe2)
		  {
				System.out.println("Name Serv Repl: socket inesistente, chiusura non riuscita");
			}
		catch (ClassNotFoundException cnfe1)
		  {
			}
		catch (ArrayIndexOutOfBoundsException aioobe)
		  {
			try
			  {
	  		System.out.println("Name Serv Repl: accesso all'array errato");
				in.close();
				System.out.println("Name Serv Repl: chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("Name Serv Repl: chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("Name Serv Repl: chiusura socket riuscita");
				}
			catch (IOException io3)
			  {
				System.out.println("Name Serv Repl: chiusura socket non riuscita");
				}
			catch (NullPointerException npe3)
			  {
				System.out.println("Name Serv Repl: socket inesistente, chiusura non riuscita");
				}
			}
		}
	
	/**
	Metodo: genera una lista dei Server di Chat registrati con relativi
	indirizzi estraendola e mandandola all'altro Name Server un
	elemento alla volta. <BR>
	*/
	private void generatoreTabella()
	  {
		try
		  {
			System.out.println("NS1: Generatore tabella in esecuzione...");
			String nome=null;
			InetAddress ind=null;
			TabellaServerDiChat copiatabsdc=new TabellaServerDiChat(mainclass);
			copiatabsdc=mainclass.tabsdc.getCopiaTabella();
			System.out.println("NS1: Generata copia tabella Server di Chat");
			int dim=copiatabsdc.size();
			System.out.println("NS1: Dimensione copia tabella calcolata...");		
			Integer dimensione=new Integer (dim);
			out.writeObject(dimensione);
			System.out.println("NS1: Dimensione mandata a NS2...");
			for (int i=0;i<dim;i++)
			  {				
				nome=copiatabsdc.getElementName(i);
				ind=copiatabsdc.getElementAddress(i);
				System.out.println("NS1: elemento "+i+": "+nome+" "+ind+" estratto");				
				out.writeObject(nome);
				out.writeObject(ind);
				System.out.println("NS1: elemento "+i+": "+nome+" "+ind+" mandato");
				}
			System.out.println("NS1: Generazione tabella riuscita");
			in.close();
			System.out.println("NS1 (Gen tab): chiusura flusso di ingresso riuscita");
			out.close();
			System.out.println("NS1 (Gen tab): chiusura flusso di uscita riuscita");
			socket.close();
			System.out.println("NS1 (Gen tab): chiusura socket riuscita");
			}
		catch (IOException ioe1)
		  {
			try
			  {
			  System.out.println("NS1 (Gen tab): socket fallita");
	  		in.close();
		  	System.out.println("NS1 (Gen tab): chiusura flusso di ingresso riuscita");
			  out.close();
				System.out.println("NS1 (Gen tab): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS1 (Gen tab): chiusura socket riuscita");
				}
			catch (IOException ioe2)
			  {
				System.out.println("NS1 (Gen tab): chiusura socket non riuscita");
				}
			catch (NullPointerException npe1)
			  {
				System.out.println("NS1 (Gen tab): socket inesistente, chiusura non riuscita");
				}
			}
		catch (NullPointerException npe2)
		  {
			System.out.println("NS1 (Gen tab): socket inesistente");
			} 
		catch (ArrayIndexOutOfBoundsException aioobe)
		  {
			try
			  {
	  		System.out.println("NS1 (Gen tab): accesso all'array errato");
				in.close();
				System.out.println("NS1 (Gen tab): chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("NS1 (Gen tab): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS1 (Gen tab): chiusura socket riuscita");
				}
			catch (IOException io3)
			  {
				System.out.println("NS1 (Gen tab): chiusura socket non riuscita");
				}
			catch (NullPointerException npe3)
			  {
				System.out.println("NS1 (Gen tab): socket inesistente, chiusura non riuscita");
				}
			}
		}
		
	/**
	Metodo: registra un Server di Chat nella Tabella dei Server di Chat 
	nel Name Server Secondario. <BR>
	Riceve il nome e l'indirizzo del Server di Chat da registrare e
	invia OK o FAIL. <BR>
	*/
	private void registrazioneSDCsuNS2()
	  {
		try
		  {
			System.out.println("NS2: Registrazione SDC in esecuzione...");
			String nomesdc=(String)in.readObject();
			InetAddress indsdc=(InetAddress)in.readObject();
			System.out.println("NS2: elemento: "+nomesdc+" "+indsdc+" ricevuto");
			int codiceerrore=mainclass.tabsdc.addElement(nomesdc,indsdc);
			if (codiceerrore==0)
			  {
				System.out.println("NS2: Registrazione avvenuta con successo");
				out.writeObject("OK");
				}
			else
			  {
				if (codiceerrore==-1)
				  System.out.println("NS2: Registrazione non avvenuta, tabella piena");
				if (codiceerrore==-2)
				  System.out.println("NS2: Registrazione non avvenuta, elemento gi presente");
				out.writeObject("FAIL");
				}
			in.close();
			System.out.println("NS2 (Reg): chiusura flusso di ingresso riuscita");
			out.close();
			System.out.println("NS2 (Reg): chiusura flusso di uscita riuscita");
			socket.close();
			System.out.println("NS2 (Reg): chiusura socket riuscita");
			}
		catch (IOException ioe1)
		  {
			try
			  {
			  System.out.println("NS2 (Reg): socket fallita");
	  		in.close();
		  	System.out.println("NS2 (Reg): chiusura flusso di ingresso riuscita");
			  out.close();
		  	System.out.println("NS2 (Reg): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS2 (Reg): chiusura socket riuscita");
				}
			catch (IOException ioe2)
			  {
				System.out.println("NS2 (Reg): chiusura socket non riuscita");
				}
			catch (NullPointerException npe1)
			  {
				System.out.println("NS2 (Reg): socket inesistente, chiusura non riuscita");
				}
			}
		catch (NullPointerException npe2)
		  {
			System.out.println("NS2 (Reg): socket inesistente");
			}
		catch (ClassNotFoundException cnfe1)
		  {
			}		  
		catch (ArrayIndexOutOfBoundsException aioobe)
		  {
			try
			  {
	  		System.out.println("NS2 (Reg): accesso all'array errato");
				in.close();
				System.out.println("NS2 (Reg): chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("NS2 (Reg): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS2 (Reg): chiusura socket riuscita");
				}
			catch (IOException io3)
			  {
				System.out.println("NS2 (Reg): chiusura socket non riuscita");
				}
			catch (NullPointerException npe3)
			  {
				System.out.println("NS2 (Reg): socket inesistente, chiusura non riuscita");
				}
			}
	}
		
	/**
	Metodo: deregistra un Server di Chat nella Tabella dei Server di Chat 
	nel Name Server Secondario.
	Riceve il nome del Server di Chat da deregistrare invia OK o FAIL. <BR>
	*/
	private void deregistrazioneSDCsuNS2()
    {
		try
		  {
			System.out.println("NS2: Deregistrazione SDC in esecuzione...");
			String nomesdc=(String)in.readObject();
			System.out.println("NS1: Ricevuto nome elemento da cancellare: "+nomesdc);
			if ((mainclass.tabsdc.deleteElement(nomesdc))==0)
			  {
				System.out.println("NS2: Cancellazione eseguita");
			  out.writeObject("OK");
				}
			else
			  {
				System.out.println("NS2: Cancellazione non eseguita, elemento non trovato");
			  out.writeObject("FAIL");
				}
			in.close();
			System.out.println("NS2 (Dereg): chiusura flusso di ingresso riuscita");
			out.close();
			System.out.println("NS2 (Dereg): chiusura flusso di uscita riuscita");
			socket.close();
			System.out.println("NS2 (Dereg): chiusura socket riuscita");
			}
		catch (IOException ioe1)
		  {
			try
			  {
			  System.out.println("NS2 (Dereg): socket fallita");
	  		in.close();
		  	System.out.println("NS2 (Dereg): chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("NS2 (Dereg): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS2 (Dereg): chiusura socket riuscita");					
				}
			catch (IOException ioe2)
			  {
				System.out.println("NS2 (Dereg): chiusura socket non riuscita");					
				}
			catch (NullPointerException npe1)
			  {
				System.out.println("NS2 (Dereg): socket inesistente, chiusura non riuscita");
				}
			}
		catch (NullPointerException npe2)
		  {
			System.out.println("NS2 (Dereg): socket inesistente");
			}
		catch (ClassNotFoundException cnfe1)
		  {
			}		  
		catch (ArrayIndexOutOfBoundsException aioobe)
		  {
			try
			  {
	  		System.out.println("NS2 (Dereg): accesso all'array errato");
				in.close();
				System.out.println("NS2 (Dereg): chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("NS2 (Dereg): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS2 (Dereg): chiusura socket riuscita");
				}
			catch (IOException io3)
			  {
				System.out.println("NS2 (Dereg): chiusura socket non riuscita");
				}
			catch (NullPointerException npe3)
			  {
				System.out.println("NS2 (Dereg): socket inesistente, chiusura non riuscita");
				}
			}
		}
				
  }  // fine classe
