/**
Autore Renato Ricci <BR>
25-08-00 <BR>
Versione Beta <BR>
*/

package utility_ns;

import main_ns.*;
import dati_ns.*;

import java.io.*;
import java.net.*;
import java.util.*;

/**
Classe che si occupa della gestione dell'accettazione di richieste
dei Server di Chat. <BR>
*/
public class ServerDiChatListener extends Thread
  {
  private ServerSocket serversocket=null;
  private Socket socketserverdichat=null;
	private ServerDiChatReplier sdcr;
	private MainClass mainclass;
	
 	/**
	Costruttore: crea la ServerSocket. <BR>
	*/
  public ServerDiChatListener(MainClass mc,int portaserverdichat)
	  {
	  try
		  {
			mainclass=mc;
		  serversocket=new ServerSocket(portaserverdichat);
			System.out.println("Serv di Chat List costr: creazione socket riuscita");
			}
		catch (IOException ioe1)
		  {
			System.out.println("Serv di Chat List costr: creazione socket non riuscita");
			}
		}
		
	/**
	Thread che cicla infinitamente, fino a fallimento della socket,
	in attesa di una richiesta di un Server di Chat. <BR>
	In coincidenza della richiesta fa partire il Thread Server di Chat Replier. <BR>
	*/
	public void run()
	  {
		System.out.println("Server di Chat Listener in esecuzione...");		
		boolean cicla=true;
		while (cicla)
		  {
		  try
			  {	
				System.out.println("Server di Chat List: Accept...");
				socketserverdichat=serversocket.accept();
				System.out.println("Server di Chat List: Accept eseguita");
				sdcr=new ServerDiChatReplier(mainclass,socketserverdichat);
				sdcr.start();
				}
			catch (IOException ioe1)
			  {
				try
				  {
					cicla=false;
					System.out.println("Socket Server di Chat Listener fallita");
					socketserverdichat.close(); // socket fallita
					}
				catch (IOException ioe2)
				  {
					System.out.println("Server di Chat List: Chiusura socket fallita");
					}
				catch (NullPointerException npe1)
				  {
					System.out.println("Server di Chat List: socket inesistente, chiusura fallita");
					}
				}
			catch (NullPointerException npe2)
			  {
				cicla=false;
				System.out.println("Server di Chat List: socket inesistente");
				}
		  }		
		}	
				
  }  // fine classe
	
