/**
Autore Renato Ricci <BR>
27-08-00 <BR> 
Versione Beta <BR>
*/

package utility_ns;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.String;

import dati_ns.*;
import main_ns.*;

/**
Classe che si occupa del riconoscimento della richiesta di un Server di Chat,
della elaborazione e della generazione della risposta. <BR>
*/
public class ServerDiChatReplier extends Thread
  {
	private Socket socket=null,socket_ns=null;
  private ObjectInputStream in=null,from_ns=null;
  private ObjectOutputStream out=null,to_ns=null;
  private MainClass mainclass;
  
  /**
	Costruttore: inizializza i flussi di ingresso e uscita verso il
	Server di Chat. <BR>
	*/
  public ServerDiChatReplier(MainClass mc,Socket s)
	  {
		try
		  {
			mainclass=mc;
			socket=s;
			in=new ObjectInputStream(socket.getInputStream());
			System.out.println("Server di Chat Repl costr: creato flusso di ingresso...");
	    out=new ObjectOutputStream(socket.getOutputStream());   
			System.out.println("Server di Chat Repl costr: creato flusso di uscita...");
			}
		catch (IOException ioe1)
		  {
			try
			  {
				System.out.println("Server di Chat Repl costr: socket fallita");
				in.close();
				System.out.println("Server di Chat Repl costr: chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("Server di Chat Repl costr: chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("Server di Chat Repl costr: chiusura socket riuscita");
				}
			catch (IOException ioe2)
			  {
				System.out.println("Server di Chat Repl costr: chiusura socket non riuscita");
				}
			catch (NullPointerException npe1)
			  {
				System.out.println("Server di Chat Repl costr: socket inesist, chiusura non riuscita");
				}
			}
		catch (NullPointerException npe2)
		  {
			System.out.println("Server di Chat Repl costr: socket inesitente");
			}
		catch (ArrayIndexOutOfBoundsException aioobe)
		  {
			try
			  {
	  		System.out.println("Server di Chat Repl costr: accesso all'array errato");
				out.writeObject("FAIL");
				in.close();
				System.out.println("Server di Chat Repl costr: chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("Server di Chat Repl costr: chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("Server di Chat Repl costr: chiusura socket riuscita");
				}
			catch (IOException io3)
			  {
				System.out.println("Server di Chat Repl costr: chiusura socket non riuscita");
				}
			catch (NullPointerException npe3)
			  {
				System.out.println("Server di Chat Repl costr: socket inesist, chiusura non riuscita");
				}
			}
		}
		
	/**
	Thread che riceve la richiesta di un Server di Chat, verifica se il Name Server
	 abilitato a rispondere, legge il tipo di richiesta e invoca il metodo
	che risponde a tale richiesta. <BR>
	*/
	public void run()
	  {
		try
		  {
			System.out.println("Server di Chat Repl: in esecuzione...");
      if (mainclass.primario.verificaCaduta()) // Se sono effettivamente il Primario		    
			  {
				String str=(String)in.readObject();
			  System.out.println("Server di Chat Repl: ricevuta richiesta da SDC");
		    if ((str.equals("SCREQS"))||(str.equals("SCREGS"))||(str.equals("SCDRGS")))
					{
					if (str.equals("SCREQS"))
					  {
						System.out.println("NS1: ricevuta richiesta lista SDC da SDC");
			      generatoreListaSDC();
						}
			    if (str.equals("SCREGS"))
					  {
						System.out.println("NS1: ricevuta richiesta reg SDC da SDC");
			      registrazioneSDC();
						}
			    if (str.equals("SCDRGS"))
					  {
						System.out.println("NS1: ricevuta richiesta dereg SDC da SDC");
				    deregistrazioneSDC();
						}
					}
				else	     
			    System.out.println("Server di Chat Repl: richiesta da SDC non corretta");			
				}
			else
				{
	      System.out.println("Server di Chat Repl: richiesta da SDC a NS2 rifiutata");
			  in.close();
			  System.out.println("Server di Chat Repl: chiusura flusso di ingresso riuscita");
				out.close();
			  System.out.println("Server di Chat Repl: chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("Server di Chat Repl: chiusura socket riuscita");					
        }
			}
		catch (IOException ioe1)
		  {
			try
			  {
				System.out.println("Server di Chat Repl: socket fallita");
				in.close();
		  	System.out.println("Server di Chat Repl: chiusura flusso di ingresso riuscita");
				out.close();
		  	System.out.println("Server di Chat Repl: chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("Server di Chat Repl: chiusura socket riuscita");
				}
			catch (IOException ioe2)
			  {
				System.out.println("Server di Chat Repl: chiusura socket non riuscita");
				}
			catch (NullPointerException npe1)
			  {
				System.out.println("Server di Chat Repl: socket inesistente, chiusura non riuscita");
				}
			}
		catch (NullPointerException npe2)
		  {			
			System.out.println("Server di Chat Repl: socket inesistente");
			}
		catch (ClassNotFoundException cnfe1)
		  {
			}
		catch (ArrayIndexOutOfBoundsException aioobe)
		  {
			try
			  {
	  		System.out.println("Server di Chat Repl: accesso all'array errato");
				out.writeObject("FAIL");
		    in.close();
				System.out.println("Server di Chat Repl: chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("Server di Chat Repl: chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("Server di Chat Repl: chiusura socket riuscita");
				}
			catch (IOException io3)
			  {
				System.out.println("Server di Chat Repl: chiusura socket non riuscita");
				}
			catch (NullPointerException npe3)
			  {
				System.out.println("Server di Chat Repl: socket inesistente, chiusura non riuscita");
				}
			}
		}
		
	/**
	Metodo: genera una lista dei Server di Chat registrati con relativi
	indirizzi estraendola e mandandola al Server di Chat che l'ha richiesta un
	elemento alla volta. <BR>
	*/
  private void generatoreListaSDC()
	  {
		try
		  {
			System.out.println("NS1: Generatore lista in esecuzione...");
			String nome=null;
			InetAddress ind=null;
			TabellaServerDiChat copiatabsdc=new TabellaServerDiChat(mainclass);
			copiatabsdc=mainclass.tabsdc.getCopiaTabella();
			System.out.println("NS1: Generata copia tabella Server di Chat");
			int dim=copiatabsdc.size();
			System.out.println("NS1: Dimensione "+dim+" tabella calcolata...");		
			Integer dimensione=new Integer(dim);
			out.writeObject(dimensione);
			System.out.println("NS1: Dimensione mandata a SDC...");
			for (int i=0;i<dim;i++)
			  {				
				nome=copiatabsdc.getElementName(i);
				ind=copiatabsdc.getElementAddress(i);
				System.out.println("NS1: elemento "+i+": "+nome+" "+ind+" estratto");				
				out.writeObject((String) nome);
				out.writeObject((InetAddress) ind);
				System.out.println("NS1: elemento "+i+": "+nome+" "+ind+" mandato");
				}
			System.out.println("NS1: Generazione lista riuscita");
			in.close();
			System.out.println("NS1 (Gen lista): chiusura flusso di ingresso riuscita");
			out.close();
			System.out.println("NS1 (Gen lista): chiusura flusso di uscita riuscita");
			socket.close();
			System.out.println("NS1 (Gen lista): chiusura socket riuscita");
			}
		catch (IOException ioe1)
		  {
			try
			  {
			  System.out.println("NS1 (Gen lista): socket fallita");
	  		in.close();
		  	System.out.println("NS1 (Gen lista): chiusura flusso di ingresso riuscita");
			  out.close();
				System.out.println("NS1 (Gen lista): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS1 (Gen lista): chiusura socket riuscita");
				}
			catch (IOException ioe2)
			  {
				System.out.println("NS1 (Gen lista): chiusura socket non riuscita");
				}
			catch (NullPointerException npe1)
			  {
				System.out.println("NS1 (Gen lista): socket inesistente, chiusura non riuscita");
				}
			}
		catch (NullPointerException npe2)
		  {
			System.out.println("NS1 (Gen lista): socket inesistente");
			} 
		catch (ArrayIndexOutOfBoundsException aioobe)
		  {
			try
			  {
	  		System.out.println("NS1 (Gen lista): accesso all'array errato");
				in.close();
				System.out.println("NS1 (Gen lista): chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("NS1 (Gen lista): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS1 (Gen lista): chiusura socket riuscita");
				}
			catch (IOException io3)
			  {
				System.out.println("NS1 (Gen lista): chiusura socket non riuscita");
				}
			catch (NullPointerException npe3)
			  {
				System.out.println("NS1 (Gen lista): socket inesistente, chiusura non riuscita");
				}
			}
		}
			
	/**
	Metodo: registra un Server di Chat nella Tabella dei Server di Chat 
	nel Name Server Primario e invoca l'eventuale registrazione sul Secondario. <BR>
	Riceve il nome e l'indirizzo del Server di Chat da registrare e
	invia OK o FAIL. <BR>
	*/
  private void registrazioneSDC()
	  {
		try
		  {
			System.out.println("NS1: Registrazione SDC in esecuzione...");
			String nomesdc=(String)in.readObject();
			InetAddress indsdc=(InetAddress)in.readObject();
			System.out.println("NS1: elemento: "+nomesdc+" "+indsdc+" ricevuto");
			int codiceerrore=mainclass.tabsdc.addElement(nomesdc,indsdc);
			if (codiceerrore==0)
			  {
				System.out.println("NS1: Registrazione avvenuta con successo");
				out.writeObject("OK");
				richiestaRegistrazioneSuNS2(nomesdc,indsdc);
				}
			else
			  {
				if (codiceerrore==-1)
				  System.out.println("NS1: Registrazione non avenuta, tabella piena");
				if (codiceerrore==-2)
				  System.out.println("NS1: Registrazione non avenuta, elemento gi presente");
				out.writeObject("FAIL");
				}
			in.close();
			System.out.println("NS1 (Reg): chiusura flusso di ingresso riuscita");
			out.close();
			System.out.println("NS1 (Reg): chiusura flusso di uscita riuscita");
			socket.close();
			System.out.println("NS1 (Reg): chiusura socket riuscita");					
			}
		catch (IOException ioe1)
		  {
			try
			  {
				out.writeObject("FAIL");
			  System.out.println("NS1 (Reg): socket fallita");
	  		in.close();
		  	System.out.println("NS1 (Reg): chiusura flusso di ingresso riuscita");
			  out.close();
		  	System.out.println("NS1 (Reg): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS1 (Reg): chiusura socket riuscita");
				}
			catch (IOException ioe2)
			  {
				System.out.println("NS1 (Reg): chiusura socket non riuscita");
				}
			catch (NullPointerException npe1)
			  {
				System.out.println("NS1 (Reg): socket inesistente, chiusura non riuscita");
				}
			}
		catch (NullPointerException npe2)
		  {
			System.out.println("NS1 (Reg): socket inesistente");
			}
		catch (ClassNotFoundException cnfe1)
		  {
			}		  
		catch (ArrayIndexOutOfBoundsException aioobe)
		  {
			try
			  {
	  		System.out.println("NS1 (Reg): accesso all'array errato");
				out.writeObject("FAIL");
				in.close();
				System.out.println("NS1 (Reg): chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("NS1 (Reg): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS1 (Reg): chiusura socket riuscita");
				}
			catch (IOException io3)
			  {
				System.out.println("NS1 (Reg): chiusura socket non riuscita");
				}
			catch (NullPointerException npe3)
			  {
				System.out.println("NS1 (Reg): socket inesistente, chiusura non riuscita");
				}
			}
		}
			
	/**
	Metodo: deregistra un Server di Chat nella Tabella dei Server di Chat 
	nel Name Server Primario e invoca l'eventuale deregistrazione sul Secondario.
	Riceve il nome del Server di Chat da deregistrare e non invia alcuna risposta. <BR>
	*/
	private void deregistrazioneSDC()
    {
		try
		  {
			System.out.println("NS1: Deregistrazione SDC in esecuzione...");
			String nomesdc=(String)in.readObject();
			System.out.println("NS1: Ricevuto nome elemento da cancellare: "+nomesdc);
			if ((mainclass.tabsdc.deleteElement(nomesdc))==0)
			  {
			  System.out.println("NS1: Cancellazione eseguita");
				richiestaDeregistrazioneSuNS2(nomesdc);
        }
			else
			  System.out.println("NS1: Cancellazione non eseguita: elemento non trovato");
			in.close();
			System.out.println("NS1 (Dereg): chiusura flusso di ingresso riuscita");
			out.close();
			System.out.println("NS1 (Dereg): chiusura flusso di uscita riuscita");
			socket.close();
			System.out.println("NS1 (Dereg): chiusura socket riuscita");
			}
		catch (IOException ioe1)
		  {
			try
			  {
			  System.out.println("NS1 (Dereg): socket fallita");
	  		in.close();
		  	System.out.println("NS1 (Dereg): chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("NS1 (Dereg): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS1 (Dereg): chiusura socket riuscita");					
				}
			catch (IOException ioe2)
			  {
				System.out.println("NS1 (Dereg): chiusura socket non riuscita");					
				}
			catch (NullPointerException npe1)
			  {
				System.out.println("NS1 (Dereg): socket inesistente, chiusura non riuscita");
				}
			}
		catch (NullPointerException npe2)
		  {
			System.out.println("NS1 (Dereg): socket inesistente");
			}
		catch (ClassNotFoundException cnfe1)
		  {
			}		  
		catch (ArrayIndexOutOfBoundsException aioobe)
		  {
			try
			  {
	  		System.out.println("NS1 (Dereg): accesso all'array errato");
				in.close();
				System.out.println("NS1 (Dereg): chiusura flusso di ingresso riuscita");
				out.close();
				System.out.println("NS1 (Dereg): chiusura flusso di uscita riuscita");
				socket.close();
				System.out.println("NS1 (Dereg): chiusura socket riuscita");
				}
			catch (IOException io3)
			  {
				System.out.println("NS1 (Dereg): chiusura socket non riuscita");
				}
			catch (NullPointerException npe3)
			  {
				System.out.println("NS1 (Dereg): socket inesistente, chiusura non riuscita");
				}
			}
		}
		
	/**
	Metodo: richiede la registrazione di un Server di Chat sul Name
	Server Secondario inviandogli nome e indirizzo. Riceve OK o FAIL. <BR>
	*/
  private void richiestaRegistrazioneSuNS2(String nome_sdc,InetAddress ind_sdc)
    {
		System.out.println("NS1: Richiesta registrazione SDC su NS2 in esecuzione...");
		String ris="FAIL";
		while (ris.equals("FAIL")) 
		// Ripeto l'operazione finch non ho successo o la socket non fallisce
			{
			try
		    {
				InetAddress indaltronameserver=InetAddress.getByName(mainclass.indnome);
			  socket_ns=new Socket(indaltronameserver,mainclass.portaaltronameserver);
		  	System.out.println("NS1 (Rich reg su NS2): creazione socket riuscita");
	      to_ns=new ObjectOutputStream(socket_ns.getOutputStream());
				System.out.println("NS1 (Rich reg su NS2): creato flusso di uscita...");
			  from_ns=new ObjectInputStream(socket_ns.getInputStream());
				System.out.println("NS1 (Rich reg su NS2): creato flusso di ingresso...");
			  to_ns.writeObject("SCREGN");
				System.out.println("NS1 (Rich reg su NS2): inviata richiesta");
			  to_ns.writeObject(nome_sdc);
				to_ns.writeObject(ind_sdc);
	  		System.out.println("NS1 (Rich reg su NS2): elem "+nome_sdc+" "+ind_sdc+" inviato");
			  ris=(String)from_ns.readObject(); // ris  "OK" oppure "FAIL"
				System.out.println("NS1 (Rich reg su NS2): risultato "+ris);
				if (ris.equals("FAIL"))
				  System.out.println("NS1 (Rich reg su NS2): Ritento...");
			  from_ns.close();
	    	System.out.println("NS1 (Rich reg su NS2): chiusura flusso di ingresso riuscita");
				to_ns.close();
				System.out.println("NS1 (Rich reg su NS2): chiusura flusso di uscita riuscita");
				socket_ns.close();
    	 	System.out.println("NS1 (Rich reg su NS2): chiusura socket riuscita");					
				}
			catch (IOException ioe1)
		    {
				try
				  {
			    ris="ESCI";
				  System.out.println("NS1 (Rich reg su NS2): socket fallita, reg non riuscita");
				  from_ns.close();
		    	System.out.println("NS1 (Rich reg su NS2): chiusura flusso di ingresso riuscita");
  				to_ns.close();
		    	System.out.println("NS1 (Rich reg su NS2): chiusura flusso di uscita riuscita");
					socket_ns.close();
	    	 	System.out.println("NS1 (Rich reg su NS2): chiusura socket riuscita");					
					}
				catch (IOException io2)
				  {
	    	 	System.out.println("NS1 (Rich reg su NS2): chiusura socket non riuscita");					
					}
			  catch (NullPointerException npe1)
	  		  {
		    	System.out.println("NS1 (Rich reg su NS2): socket inesist, chiusura non riuscita");
					}
		  	}
		  catch (NullPointerException npe2)
		    {
		    ris="ESCI";
		    System.out.println("NS1 (Rich reg su NS2): socket inesistente");					
		  	}
			catch (ClassNotFoundException cnfe1)
			  {
				}
		  catch (ArrayIndexOutOfBoundsException aioobe)
		    {
			  try
			    {
	    		System.out.println("NS1 (Rich reg su NS2): accesso all'array errato");
		  		in.close();
			  	System.out.println("NS1 (Rich reg su NS2): chiusura flusso di ingresso riuscita");
				  out.close();
  				System.out.println("NS1 (Rich reg su NS2): chiusura flusso di uscita riuscita");
	  			socket.close();
		  		System.out.println("NS1 (Rich reg su NS2): chiusura socket riuscita");
			  	}
			  catch (IOException io3)
			    {
				  System.out.println("NS1 (Rich reg su NS2): chiusura socket non riuscita");
				  }
			  catch (NullPointerException npe3)
			    {
				  System.out.println("NS1 (Rich reg su NS2): socket inesist, chiusura non riuscita");
				  }
			  }
			}
    }		

	/**
	Metodo: richiede la deregistrazione di un Server di Chat sul Name
	Server Secondario inviandogli il nome. Riceve OK o FAIL. <BR>
	*/
	private void richiestaDeregistrazioneSuNS2(String nome_sdc)
    {
		System.out.println("NS1: Richiesta deregistrazione SDC su NS2 in esecuzione...");
		String ris="FAIL";
		while (ris.equals("FAIL")) 
		// Ripeto l'operazione finch non ho successo o la socket non fallisce
			{
			try
		    {
				InetAddress indaltronameserver=InetAddress.getByName(mainclass.indnome);
			  socket_ns=new Socket(indaltronameserver,mainclass.portaaltronameserver);
		  	System.out.println("NS1 (Rich dereg su NS2): creazione socket riuscita");
	      to_ns=new ObjectOutputStream(socket_ns.getOutputStream());
			  System.out.println("NS1 (Rich dereg su NS2): creato flusso di uscita...");
			  from_ns=new ObjectInputStream(socket_ns.getInputStream());
				System.out.println("NS1 (Rich dereg su NS2): creato flusso di ingresso...");
			  to_ns.writeObject("SCDRGN");
				System.out.println("NS1 (Rich dereg su NS2): inviata richiesta");
			  to_ns.writeObject(nome_sdc);
	  		System.out.println("NS1 (Rich dereg su NS2): nome elemento: "+nome_sdc+" inviato");
			  ris=(String)from_ns.readObject(); // ris  "OK" oppure "FAIL"
				System.out.println("NS1 (Rich dereg su NS2): risultato "+ris);
				if (ris.equals("FAIL"))
				  System.out.println("NS1 (Rich dereg su NS2): Ritento...");
			  from_ns.close();
	    	System.out.println("NS1 (Rich dereg su NS2): chiusura flusso di ingresso riuscita");
				to_ns.close();
				System.out.println("NS1 (Rich dereg su NS2): chiusura flusso di uscita riuscita");
				socket_ns.close();
    	 	System.out.println("NS1 (Rich dereg su NS2): chiusura socket riuscita");					
				}
			catch (IOException ioe1)
		    {
				try
				  {
			    ris="ESCI";
				  System.out.println("NS1 (Rich dereg su NS2): socket fallita, dereg non riuscita");
				  from_ns.close();
		    	System.out.println("NS1 (Rich dereg su NS2): chiusura flusso di ingresso riuscita");
  				to_ns.close();
		    	System.out.println("NS1 (Rich dereg su NS2): chiusura flusso di uscita riuscita");
					socket_ns.close();
	    	 	System.out.println("NS1 (Rich dereg su NS2): chiusura socket riuscita");					
					}
				catch (IOException io2)
				  {
	    	 	System.out.println("NS1 (Rich dereg su NS2): chiusura socket non riuscita");					
					}
			  catch (NullPointerException npe1)
	  		  {
		    	System.out.println("NS1 (Rich dereg su NS2): socket inesist, chiusura non riuscita");					
		  		}
		  	}
		  catch (NullPointerException npe2)
		    {
		    System.out.println("NS1 (Rich dereg su NS2): socket inesistente");					
		  	}
			catch (ClassNotFoundException cnfe1)
			  {
				}
		  catch (ArrayIndexOutOfBoundsException aioobe)
		    {
			  try
			    {
	    		System.out.println("NS1 (Rich dereg su NS2): accesso all'array errato");
		  		in.close();
			  	System.out.println("NS1 (Rich dereg su NS2): chiusura flusso di ingresso riuscita");
				  out.close();
  				System.out.println("NS1 (Rich dereg su NS2): chiusura flusso di uscita riuscita");
	  			socket.close();
		  		System.out.println("NS1 (Rich dereg su NS2): chiusura socket riuscita");
			  	}
			  catch (IOException io3)
			    {
				  System.out.println("NS1 (Rich dereg su NS2): chiusura socket non riuscita");
				  }
			  catch (NullPointerException npe3)
			    {
				  System.out.println("NS1 (Rich dereg su NS2): socket inesist, chiusura non riuscita");
				  }
			  }
			}
    }		
		
  }  // fine classe
