package comunicazione1;

import java.net.*;
import java.io.*;
import recovery.*;
import java.util.*;
import utilita.*;

/**
Autore: Barbara Allori<BR>
Data inizio: 27/12/1999<BR>
Versione: 1.0-beta<BR>
Si occupa della connessione verso il name server.
*/

public class ConnectNS extends Thread
{
	private InetAddress serverp=null,servers=null;
 	private int portap,portas;	//portap=porta del name server primario portas=porta del name server secondario
	private Socket client=null;
	private RecoveryAlgorithm myrecovery;

 //Costruttore usato dalla classe RecoveryAlgorithm
 public ConnectNS(RecoveryAlgorithm ra)
	{
		myrecovery=ra;
	 	try
		{
			System.out.println(CostantiAlt.NSP);
			serverp=InetAddress.getByName(CostantiAlt.NSP);
			System.out.println("(CNS) Server primario= "+serverp);
			servers=InetAddress.getByName(CostantiAlt.NSS);
			System.out.println("(CNS) Server secondario= "+servers);
			System.out.println(CostantiAlt.NSPFORSC);
		  portap=CostantiAlt.NSPFORSC;	
  	  portas=CostantiAlt.NSSFORSC;	

		}
	 	catch 	(UnknownHostException uhe)
		{
			System.out.println("(CNS) UnknownHostException");
			System.out.println("(CNS) Scambio name server primario con name server secondario");
			setNameServerPrimario();
			setPortaPrimario();
		}	
		try
		{
			sleep(10000);
		}
		catch (InterruptedException ie)
		{
		}
		myrecovery.setListaServer(getListaServer());
		//System.out.println("Fine costruttore CNS");
	}
	
/**
Aggiorna l'indirizzo del name server primario.
Usata in caso di recovery non fa altro che scambiare tra loro name server primario e name server secondario.
*/
 private void setNameServerPrimario()
	{
	  InetAddress temp;
		temp=serverp;
		serverp=servers;
		servers=temp;
	}
	
/**
Aggiorna la porta del name server primario.
Usato in caso di recovery non fa altro che scambiare tra loro la porta del primario con quella del secondario
*/
private void setPortaPrimario()
{
	int temp;
	temp=portap;
	portap=portas;
	portas=temp;
}

/**
Restituisce l'indirizzo del name server primario.
Tale indirizzo servir per ottenere l'indirizzo del server di chat di partenza.
*/
 public InetAddress getNameServerPrimario()
	{ return serverp;}

/**
Restituisce il numero di porta tcp del name server primario.
*/
private int getPortaPrimario()
{
	return portap;
}

/**
Testa se  possiblile connettersi al name server primario.
Restituisce true se la connessione  andata a buon fine.
*/
private boolean isConnected()
{
	try
		{
			//Apro una connessione con il server primario
			System.out.println("(CNS) Sto per fare una new socket verso il name server primario "+getNameServerPrimario()+" su porta "+getPortaPrimario());
			client=new Socket(getNameServerPrimario(),getPortaPrimario());
			System.out.println("(CNS) Connessione stabilita");
			return true;
		}
	catch (UnknownHostException uhe)
	{
		return false;
	}
	catch (IOException ioe)
	{
		return false;
	}
	catch (NullPointerException npe)
	{
		return false;
	}
}//fine metodo isConnected

/**
Ottiene dal name server la lista di tutti i server di chat presenti nel sistema.
Gli elementi dispari dell'ArrayList rappresentano i vari indirizzi.
*/
public ArrayList getListaServer()
{
	ObjectOutputStream out=null;
	ObjectInputStream in=null;	
	boolean ciclo=false;
	ArrayList arraylist=new ArrayList();
	int j=0;
	do
	{
		while (!isConnected() && j<CostantiAlt.NUMEROTENTATIVI) 
		{
			setNameServerPrimario();
			setPortaPrimario();
			try
			{
				this.sleep(CostantiAlt.DELAYFORTENTATIVI);
			}
			catch (InterruptedException ie)
			{
			}
			j++;
		}//fine del while
		try
		{
			System.out.println("(CNS) Acquisisco il flusso di uscita");
			//Acquisisco il flusso di uscita su cui scrivo
			out=new ObjectOutputStream(client.getOutputStream());
			System.out.println("(CNS) Acquisisco il flusso di ingresso...");
	  	//Acquisisco il flusso di ingresso su cui leggo
			in=new ObjectInputStream(client.getInputStream());
			System.out.println("(CNS) ...ho acquisito il flusso di ingresso");
			//implemento op.5
			out.writeObject(CostantiCom.SCREQS);
			System.out.println("(CNS) Ho inviato la richiesta lista server");
			Integer length=(Integer)in.readObject();
			//System.out.println("(CNS) ho fatto la read");
			int n=length.intValue();
			System.out.println("(CNS) Lunghezza lista server "+n);
			for(int i=0;i<n;i++)
			{
				arraylist.add(in.readObject());//leggo il nome
				arraylist.add(in.readObject());//poi l'indirizzo
				//System.out.println("Letto elemento "+arraylist);
			}
			System.out.println("(CNS) Lista totale "+arraylist);
			ciclo=false;
		}
		catch (IOException ioe) 
		{
			System.out.println("(CNS) Inverto server primario con secondario");
			setNameServerPrimario();
			setPortaPrimario();
			try
			{
				this.sleep(CostantiAlt.DELAYFORTENTATIVI);
			}
			catch (InterruptedException ie)
			{
			}
			ciclo=true;
		}	
		catch (NullPointerException npe1)	 
		{
			ciclo=true;
		}
		catch (ClassNotFoundException cnfe) 
		{
		}	
		try
		{
			out.close();
			in.close();
		  client.close();
		}
		catch (IOException ioe2)
		{
			System.out.println("(CNS) Problemi in chiusura");
			setNameServerPrimario();
			setPortaPrimario();
			try
			{
				this.sleep(CostantiAlt.DELAYFORTENTATIVI);
			}
			catch (InterruptedException ie)
			{
			}
			ciclo=true;		
		}
		j++;
	}//fine del do
	while (ciclo && j<CostantiAlt.NUMEROTENTATIVI);
	//System.out.println("sono in fondo");
	return arraylist;
}//fine metodo getListaServer()
/**
Si occupa di riferire al name server primario che il server server  catuto.
Il name server primario dovr provvedere alla sua eliminazione.
Usato in caso di recovery dalla classe Recoveryalgorithm.
*/
public void deregistraServer(String server)
{
	ObjectOutputStream out=null;
	ObjectInputStream in=null;
	boolean ciclo=false;
	int i=0;
	do
	{
		while (!isConnected() && i<CostantiAlt.NUMEROTENTATIVI) 
		{
			setNameServerPrimario();
			setPortaPrimario();
			try
			{
				this.sleep(CostantiAlt.DELAYFORTENTATIVI);
			}
			catch (InterruptedException ie)
			{
			}
			i++;
		}//fine del while
		try
		{
			System.out.println("(CNS) Acquisisco il flusso d'uscita...");
			//Acquisisco il flusso di uscita su cui scrivo
			out=new ObjectOutputStream(client.getOutputStream());
			System.out.println("(CNS) ..acquisito flusso d'uscita");
			//Acquisisco iol flusso di ingresso anche se non mi server
			//perche` il name server apre anche il flusso di uscita
			//anche se non lo usa
			in=new ObjectInputStream(client.getInputStream());
			System.out.println("Acquisito anche il flusso di ingresso");
			System.out.println("(CNS) Invio inf per deregistrazione server "+server);
			//implemento op.7
			out.writeObject(CostantiCom.SCDRGS);
			out.writeObject(server);
			System.out.println("(CNS) Inviate inf per deregistrazione");
			out.close();
			in.close();
			client.close();
			ciclo=false;
		}
		catch (IOException ioe) 
		{
			System.out.println("(CNS) Ricevuta IOException");
			setNameServerPrimario();
			setPortaPrimario();
			try
			{
				this.sleep(CostantiAlt.DELAYFORTENTATIVI);
			}
			catch (InterruptedException ie)
			{
			}
			ciclo=true;
		}	
		catch (NullPointerException npe1)	 
		{
			ciclo=true;
		}
		i++;
	}//fine del do
	while (ciclo && i<CostantiAlt.NUMEROTENTATIVI);
}//fine metodo deregistraServer()
}//fine classe

