package mainpack;

import java.net.*;
import java.util.*;
import java.io.*;

import strutturedati.*;
import scthreads.*;
import utilita.*;

/**
Autore:	Terenzio<BR>
Data:		01-09-2000<BR>
Vers:		1.0<BR>
Classe di avvio del Server di Chat. Al suo interno si trova il metodo main().
*/

public class MainClass {
	//Variabili private
	private String NSP,NSS;
	private int portaNSP, portaNSS;
	//Variabili globali
	public String nomeserver; 
	public DBStanzeLocali dbstanzelocali;
	public CacheStanze cachestanze;
	public Random rgen;
	
	//Costruttore
	
	public MainClass(String nomeserverchat) {
		nomeserver=nomeserverchat;
		NSP=CostantiAlt.NSP;
		NSS=CostantiAlt.NSS;
		portaNSP=CostantiAlt.NSPFORSC;
		portaNSS=CostantiAlt.NSSFORSC;
		boolean ok=false;
		ok=registraServerChat();
		if (!ok) {
			System.out.println("MC - (Costr) Impossibile registrare Server di Chat "+nomeserverchat);
			System.exit(-2);
		}
		dbstanzelocali=new DBStanzeLocali();
		cachestanze=new CacheStanze();
		rgen=new Random();
		ClientListener cl=new ClientListener(this,CostantiAlt.SCFORC);
		ServerChatListener scl=new ServerChatListener(this,CostantiAlt.SCFORSC);
		cl.start();
		scl.start();
	}
	
	// Metodi
	
	/**
	main - da qui parte il Server di Chat. Bisogna fornire come argomento il nome del Server di Chat 
	che si vuole avviare.
	*/
	public static void main(String args[]) {
		if (args.length<1) {
			System.out.println("Manca un argomento:  necessario fornire il nome del server di chat!");
			System.exit(-1);
		}
		MainClass mc=new MainClass(args[0]);
	} //fine main
		
	/**
	Metodo da utilizzare per scambiare le informazioni relative al Name Server Primario e Secondario.
	Tale metodo  da invocarsi quando si identifica la caduta del Name Server attualmente primario.
	*/
	public synchronized void switchNS() {
		String tempind;
		int tempporta;
		tempind=NSP;
		NSP=NSS;
		NSS=tempind;
		tempporta=portaNSP;
		portaNSP=portaNSS;
		portaNSS=tempporta;
	} // fine switchNS
	
	/**
	Metodo che contiene tutto il codice che permette di effetturare la registrazione del Server di Chat
	nel sistema.
	*/
	private boolean registraServerChat() {
		Socket ns=null;
		ObjectInputStream ois=null;
		ObjectOutputStream oos=null;
		String risultato="NESSUN RISULTATO";
		for (int i=0; i<2; i++) {
			//Connessione a NameServer
			try {
				ns=new Socket(NSP,portaNSP);
				oos=new ObjectOutputStream(ns.getOutputStream());
				ois=new ObjectInputStream(ns.getInputStream());
				System.out.println("MC - (Reg.) Aperta connessione verso NS "+NSP+" : "+portaNSP);

			}
			catch (IOException ioe) {
			//per debugging
			System.out.println("MC - (Reg.) Impossibile aprire connessione verso NS "+NSP+" : "+portaNSP);
			System.out.println("MC - (Reg.) Il NSP di default  caduto, provo sul NSS."); 
			switchNS();
			continue;
			}
			try {
				oos.writeObject(CostantiCom.SCREGS);
				oos.writeObject(nomeserver);
				oos.writeObject(InetAddress.getLocalHost());
				risultato=(String)ois.readObject();
				break;
			}
			catch (Exception e) {
				//per debugging
				System.out.println("MC - (Reg.) Impossibile comunicare con il NS "+NSP+" : "+portaNSP);
				try {
					oos.close();
					ois.close();
					ns.close();
					System.out.println("MC - (Reg.) Chiusura corretta con NS "+NSP+" : "+portaNSP+" dopo problemi di comunicazione.");
				}
				catch (IOException ioe) {
					//per debugging 
					System.out.println("MC - (Reg.) Problema chiusura comunicazione con NS "+NSP+" : "+portaNSP+" dopo problemi di comunicazione.");
					//System.exit(-4);
				}
				switchNS();
				continue;
			}
		} //fine for
		try {
			oos.close();
			ois.close();
			ns.close();
			System.out.println("MC - (Reg.) Chiusura comunicazione corretta verso NS "+NSP+" : "+portaNSP);
		}
		catch (IOException ioe) {
			//per debugging 
			System.out.println("MC - (Reg.) Impossibile chiudere comunicazione correttamente con NS "+NSP+" : "+portaNSP);
			//System.exit(-4);
		}
		//per debugging
		System.out.println("MC -(Reg.) Risultato registrazione SC: "+risultato);
		if (risultato.equals(CostantiCom.OK)) return true;
		if (risultato.equals("NESSUN RISULTATO")) return false;
		System.exit(-5);
		return false;
	} //fine registraServerChat
	
	/**
	Ritorna il Nome e la porta di ascolto per i Server di Chat del Name Server Primario.
	*/
	public synchronized NameServer getNameServer() {
		return new NameServer(NSP,portaNSP);
	} //fine getNameServer
	

} //fine classe

