package recovery;

import strutturedati.*;
import java.util.*;
import java.net.*;
import java.io.*;
import comunicazione1.*;
import utilita.*;

/**
Autore: Barbara Allori<BR>
Data inizio: 17/08/2000<BR>
Versione: 1.0<BR>
Questa classe si occupa del recovery di server di chat.
*/

public class RecoveryAlgorithm extends Thread
{
	private String stanza,utente,listautenti[]=null;//listautenti[]=contiene i nomi di tutti gli utenti presenti nella stanza
	private InetAddress server,servert;
	private InetAddress[] listaind;//contiene tutti gli indirizzi dei server di chat
	private ArrayList lista=new ArrayList();
	private int portadefault=CostantiAlt.SCFORSC,porta,portalocale,totindirizzi;
	private ConnectNS cns=null;
	private DBStanzeLocali dbsl=null;
	private InfoCopia ic=null;
	private Receiver r=null;
	private Random seme;
	public RecoveryAlgorithm(String s,DBStanzeLocali d,Random seme,String utente)
	{
		stanza=s;
		dbsl=d;
		this.seme=seme;
		this.utente=utente;
		System.out.println("B. (RA) Richiesto recovery per stanza "+stanza);
		ic=dbsl.getInfoCopia(stanza);
		System.out.println("B. (RA) Creato oggetto InfoCopia");
		//Vado a vedere se ho gi fatto il recovery
		if(!apriConnessioneCopia()) //il server di copia non risponde-> caduto
			{
				portalocale=dbsl.getPortaStanza(stanza);
				System.out.println("B. (RA) sto per creare cns");
				cns=new ConnectNS(this);//aggiorna la mia lista dei server di chat
				System.out.println("B. (RA) il cns ha fatto il suo dovere");
				try
				{
					sleep(CostantiAlt.DELAYFORTENTATIVI);
				}
				catch (InterruptedException ie) {}
				System.out.println("B. (RA) procedo nella deregistrazione");
				deregistraServer();
				System.out.println("B. (RA) Mi procuro la lista di tutti gli utenti della stanza "+stanza);
				listautenti=dbsl.getNomiUtenti(stanza);// la lista di tutti gli utenti della stanza
				System.out.println("B. (RA) Ottenuta lista utenti= "+listautenti);
				int n=listautenti.length;
				boolean ciclo=true;
				do
				{	System.out.println("B. (RA) Scelgo un ind. a caso tra quelli forniti dal name server");
					//scelgo un ind. a caso tra quelli forniti dal name server
					servert=selectServer();
					System.out.println("B. (RA) Chiedo al SdC "+servert+" di creare la stanza "+stanza);
					for(int j=0;j<n;j++)
					{	//per ogni utente della stanza posso chiedere di conoscere l'indirizzo
						r=dbsl.getReceiver(stanza,listautenti[j]);
						//chiedo al server selezionato di creare una copia della stanza 
						//e di fare entrare tutti gli utenti che vi sono
						if(apriConnessione(j,servert,listautenti[j],r.getPorta(),r.getIndirizzo(),false,portalocale)) ciclo=false;
						else 
						{
							ciclo=true;
							break;
						}
					}//fine for
				}
				while (ciclo);
				//ora devo aggiornare i dati
				System.out.println("B. (RA) Il server di chat "+servert+" ha creato la stanza");
				setServer(servert);
				aggiornaDati(getServer(),getPorta());
				inviaInfoCopia();
			}
		else 
			{
				setServer(ic.getIndirizzo());
				setPorta(ic.getPorta());
			}
	}//fine costruttore
	/**
	Cerco di stabilire una connessione con l'attuale server di copia.
	Ritorna true se l'operazione va a buon fine, false altrimenti.
	In caso di risposta true non  neccessario deregistrare il server.
	*/
 	public boolean apriConnessioneCopia()
	{ 
		try
			{
				System.out.println("B. (RA) Provo a vedere se il SdC ("+ic.getIndirizzo()+") di copia c'");
				//Apro una connessione con il server di chat di copia sulla porta di default
				Socket s=new Socket(ic.getIndirizzo(),portadefault);
				System.out.println("B. (RA) Socket creata->SdC gi recoverato");
				s.close();
				return true;
			}
			catch (UnknownHostException uhe)
			{ 
				System.out.println("B. (RA) Problemi nella creazione->devo recoverare");
				return false;
			}
			catch (IOException ioe)
			{
				System.out.println("B. (RA) Problemi nella creazione->devo recoverare");
				return false;
			}
			catch (NullPointerException npe)
			{ 
				System.out.println("B. (RA) Problemi nella creazione->devo recoverare");
				return false;
			}
	}//fine apriConnessioneCopia()
	/**
	Chiede la deregistrazione del server di copia in quanto non pi reperibile.
	*/
	public void deregistraServer()
	{
		InetAddress indserver=ic.getIndirizzo();//ind SdC da dereg8istrare
		System.out.println("B: (RA) Devo deregistrare il Sdc di indirizzo "+indserver);
		String server=null;
		int i=1;//indice dispari=Indirizzo
		boolean esci=true;
		System.out.println("B. (RA) Procedo nell'identificazione del nome del SdC da deregistrare");
		do
		{
			InetAddress indlista=(InetAddress)lista.get(i);
			System.out.println("B. (RA) Confronto "+indlista+" con "+indserver);
			if(indlista.equals(indserver))
			{
				esci=false;
				System.out.println("B. (RA)"+indlista+"="+indserver);
				server=(String)lista.get(i-1);//indice pari=nome SdC
				System.out.println("B. (RA) Quindi devo deregistrare "+server);
			}
			else i=i+2;
			System.out.println("B. (RA)"+indlista+"!="+indserver);
			if(i>lista.size()) esci=false;//elemento non presente
		}
		while (esci);
		System.out.println("B. (RA) Chiedo deregistrazione del SdC: "+server);
		cns.deregistraServer(server);
		//eseguo la deregistrazione del server di chat due volte in modo che
		//la procedura non possa fallire
		cns.deregistraServer(server);
		if(i<=lista.size())
		{
			System.out.println("B. (RA) elimino dalla mia lista l'indirizzo del server caduto e il suo nome");
			//elimino dalla mia lista l'indirizzo del server caduto e il suo nome
			int indice=lista.indexOf(indserver);
			System.out.println("B. (RA) elimino elemento "+lista.get(indice-1)+" "+lista.get(indice));
			lista.remove(indice);//rimuovo l'indirizzo
			lista.remove(indice-1);//rimuovo il nome
			InetAddress[] indtemp=new InetAddress[listaind.length-1];
			int j=0;
			System.out.println("B. (RA) elimino dalla lista degli indirizzi l'indirizzo del server di copia caduto");
			//elimino dalla lista degli indirizzi l'indirizzo del server di copia caduto
			for(i=0;i<listaind.length;i++)
			{
				if(!listaind[i].equals(indserver)) 
				{
					indtemp[j]=listaind[i];
					j++;
				}
			}
			//ho eliminato l'indirizzo deregistrato
			listaind=indtemp;
			totindirizzi=listaind.length;
		}
		//System.out.println("B. (RA) Fine deregistraServer()");
	}
	/**
	Aggiorna la lista dei server di chat.
	Tale lista viene fornita dal name server.
	*/
	public void setListaServer(ArrayList arraylist)
	{
		//System.out.println("B. (RA) Sono nel setListaServer()");
		lista=arraylist;
		int j=0;
		int i=0;
		listaind=new InetAddress[lista.size()/2];
		do
		{
			listaind[j]=(InetAddress)lista.get(2*j+1);
			System.out.println("B. (RA) listaind= "+listaind[j]);
			j++;
		}
		while(j<listaind.length);
		totindirizzi=listaind.length;
	}
	/**
	Restituisce l'indirizzo del nuovo server di copia per la stanza per cui  stato scatenato il recovery.
	*/
	public InetAddress getServer()
	{
		return server;
	}
	/**
	Restituisce il numero di porta Tcp della stanza per cui  stato chiesto il recovery.
	*/
	public int getPorta()
	{
		return porta;
	}
	/**
	Aggiorna il numero di porta Tcp della stanza per cui  stato scatenato il recovery.
	*/
	private void setPorta(int p)
	{
		porta=p;
	}
	/**
	Chiedo al server di chat selezionato di creare la stanza di copia.
	Ritorna true se l'operazione va a buon fine, false altrimenti.
	*/
	private boolean apriConnessione(int j,InetAddress s,String utente,int udp,InetAddress client,boolean c,int pl)
	{
		Socket socket=null;
		ObjectOutputStream out=null;
		ObjectInputStream in=null;
		try
			{
				//Apro una connessione con il server di chat di copia sulla porta di default
				socket=new Socket(s,portadefault);
				out=new ObjectOutputStream(socket.getOutputStream());
				in=new ObjectInputStream(socket.getInputStream());
				if(j==0)//sono il primo utente
				{
					//implemento l'operazione 12
					out.writeObject(CostantiCom.ROOMCRS);//richiesta di creazione/accesso stanza
					out.writeObject(stanza);
					Integer ip=new Integer(pl);
					out.writeObject(ip);//porta locale del SdC vivo
					out.writeObject(utente);
					out.writeObject(client);//indirizzo dell'utente
					Integer iudp=new Integer(udp);
					out.writeObject(iudp);//porta udp di ascolto dell'utente
					Boolean collegato=new Boolean(c);
					out.writeObject(collegato);
					String risp=(String)in.readObject();
					if(risp.equals(CostantiCom.FAIL)) 				
					{//posso fare anche una System.error
						socket.close();
						return false;
					}
					else
					{
						//leggo il numero della porta tcp della stanza appena creata
						Integer itcp=(Integer)in.readObject();
						setPorta(itcp.intValue());
						socket.close();
						return true;
					}
				}
				else
				{
					//implemento l'operazione 13
					out.writeObject(CostantiCom.ROOMACCS);//richiesta di creazione/accesso stanza
					out.writeObject(stanza);
					out.writeObject(utente);
					out.writeObject(client);//indirizzo dell'utente
					Integer iudp=new Integer(udp);
					out.writeObject(iudp);//porta udp di ascolto dell'utente
					Boolean collegato=new Boolean(c);
					out.writeObject(collegato);
					String risp=(String)in.readObject();
					if(risp.equals(CostantiCom.FAIL)) 				
					{//posso fare anche una System.error
						socket.close();
						return false;
					}
					else
					{
						//leggo il numero della porta tcp della stanza appena creata
						Integer itcp=(Integer)in.readObject();
						setPorta(itcp.intValue());
						socket.close();
						return true;
					}
				}//fine else per utente>1
			}
			catch (UnknownHostException uhe)
			{ 
				return false;
			}
			catch (IOException ioe)
			{
				return false;
			}
			catch (NullPointerException npe)
			{ 
				return false;
			}
			catch (ClassNotFoundException cnfe)
			{
				return false;
			}
	}
	/**
	Aggiorna l'indirizzo del server che contiene la copia della stanza per cui  stato scatenato il recovery.
	*/
	private void setServer(InetAddress s)
	{
		server=s;	
	}
	/**
	Ritorna l'indirizzo i-esimo di server di chat.
	*/
	private InetAddress selectServer()
	{
		InetAddress ind=null;
		boolean ciclo=false;
		InetAddress local=null;
		try
		{
			local=InetAddress.getLocalHost();
			System.out.println("B. (RA) Host locale= "+local);
		}
		catch (UnknownHostException uhe)
		{
			System.out.println("B. (RA) Host non trovato");
			System.exit(-5);
		}
		do
		{
			System.out.println("B. (RA) Tot indirizzi= "+totindirizzi);
			int indice=seme.nextInt(totindirizzi);
			System.out.println("B. (RA) Numero random= "+indice);
			ind=listaind[indice];
			System.out.println("B. (RA) Estratto indirizzo "+ind);
			if(ind.equals(local)) {ciclo=true;System.out.println("B. (RA) scelto host locare, riprovo");}
			else ciclo=false;
		}
		while (ciclo);
		System.out.println("B. (RA) server scelto "+ind);
		return ind;
	}
	private void aggiornaDati(InetAddress ind,int p)
	{
		dbsl.setInfoCopiaStanza(stanza,ind,p);
	}
	private void inviaInfoCopia()
	{	DatagramSocket socket=null;
		String messaggio=CostantiCom.SIST.concat(" i=").concat(getServer().getHostAddress()).concat("p=").concat(Integer.toString(getPorta()));
		byte[] buff=messaggio.getBytes();
		Receiver r;
		
		try
		{
			socket=new DatagramSocket();
		}
		catch (SocketException se)
		{
		}
		for(int i=0;i<listautenti.length;i++)
		{
			if(!utente.equals(listautenti[i]))
			{
				r=dbsl.getReceiver(stanza,listautenti[i]);
				DatagramPacket dp=new DatagramPacket(buff,buff.length,r.getIndirizzo(),r.getPorta());
				try
				{
					socket.send(dp);
					System.out.println("B. (RA) Inviato msg recovery a utente "+listautenti[i]);
					System.out.println("B. (RA) Inviato msg "+messaggio);
				}
				catch (IOException ioe)
				{
					System.out.println("B. (RA) Ricevuta IOException durante invio msg recovery");
				}
			}
			else System.out.println("B. [RA) Salto utente "+utente);	
		}
	}//fine inviaInfoCopia()	
}//fine classe

