package scthreads;

import java.util.*;
import java.net.*;
import java.io.*;

import mainpack.*;

/**
Autore:	Terenzio<BR>
Data:		01-09-2000<BR>
Vers:		1.0<BR>
Classe di ascolto delle richieste dei Client.
*/

public class ClientListener extends Thread {
	private int portadiascolto;
	private MainClass mainclass;
	private ClientReplier clientreplier;
	private ServerSocket serversocket;
		
	//Costruttore
	
	/**
	Inizializza la variabile mainclass che permetter di vedere la CacheStanza e il DBStanzeLocali del
	server di chat.
	*/
	public ClientListener(MainClass mc, int porta) {
		mainclass=mc;
		portadiascolto=porta;
		clientreplier=null;
		serversocket=null;
	}
	
	/**
	Codice eseguito all' avvio del ClientListener
	*/
	public void run() {
		System.out.println("CL - (run) in esecuzione.");
		boolean bool=true;
		try {
			serversocket=new ServerSocket(portadiascolto);
		} 
		catch (IOException ioe) { 
			// per debugging
			System.out.println("CL - (run) Impossibile aprire ServerSocket.");
			bool=false;
		}
		while (bool==true) {
			try {
				System.out.println("CL - (run) Pronto a ricevre richieste da C...");
				Socket clientsocket=serversocket.accept();
				clientreplier=new ClientReplier(mainclass, clientsocket);
				clientreplier.start();
			} 
			catch (IOException ioe) {
				// per debugging
				System.out.println("CL - (run) Impossibile effetuare la accept.");
				bool=false;
			}
		}
	}  //fine metodo run


} //fine classe

