package scthreads;


import java.util.*;
import java.net.*;
import java.io.*;

import mainpack.*;

/**
Autore:	Terenzio<BR>
Data:		01-09-2000<BR>
Vers:		1.0<BR>
Classe di ascolto delle richieste degli altri Server di Chat.
*/

public class ServerChatListener extends Thread {
	private int portadiascolto;
	private MainClass mainclass;
	private ServerChatReplier serverchatreplier;
	private ServerSocket serversocket;

	//Costruttore
	
	/**
	Inizializza la variabile mainclass che permetter di vedere la CacheStanza e il DBStanzeLocali del
	server di chat.
	*/
	public ServerChatListener(MainClass mc, int porta) {
		mainclass=mc;
		portadiascolto=porta;
		serverchatreplier=null;
		serversocket=null;
	} //fine costruttore
	
	/**
	Predispone il sistema a ricevere le richieste dagli altri Server di Chat e si mette in attesa.
	*/
	public void run() {
		System.out.println("SCL - (run) in esecuzione.");
		boolean bool=true;
		try {
			serversocket=new ServerSocket(portadiascolto);
		} 
		catch (IOException ioe) { 
			// per debugging
			System.out.println("SCL - (run) Impossibile aprire ServerSocket.");
			bool=false;
		}
		while (bool==true) {
			try {
				System.out.println("SCL - (run) Pronto a ricevere richieste da SC...");
				Socket clientsocket=serversocket.accept();
				serverchatreplier=new ServerChatReplier(mainclass, clientsocket);
				serverchatreplier.start();
			} 
			catch (IOException ioe) {
				// per debugging
				System.out.println("SCL - (run) Impossibile effetuare la accept.");
				bool=false;
			}
		}
	}	// fine run
			
			
} //fine classe

