package strutturedati;

import java.net.*;

/**
Autore:	Terenzio<BR>
Data:		01-09-2000<BR>
Vers:		1.0<BR>
Classe che contiene le informazioni di cache relative ad una stanza presente nell' intero sistema.
*/

public class InfoGlobaleStanza {
	private String nome;
	private InetAddress copia1,copia2;
	
	//Costruttori
		
	public InfoGlobaleStanza(String nome) {
		this.nome=nome;
		copia1=copia2=null;
	}
		
	public InfoGlobaleStanza(String nome, InetAddress indirizzo) {
		this.nome=nome;
		copia1=indirizzo;
		copia2=null;
	}
	
	//Metodi
		
	/**
	Restituisce l'indirizzo del primo server trovato contenente la stanza.
	*/
	public InetAddress getServer1() {
		return copia1;
	} //fine getServer1
	
	/**
	Restituisce l'indirizzo del secondo server trovato contenente la stanza. Ritorna null se la stanza
	esiste in una sola copia nel sistema.
	*/
	public InetAddress getServer2() {
		return copia2;
	} //fine getServer2
	
	/** 
	Aggiunge le informazioni relative ad un server per una data stanza. Ritorna true se le informazioni
	vengono effettivamente aggiunte false altrimenti.
	*/
	public boolean addServer(InetAddress indirizzo) {
		if (copia1==null) {
			copia1=indirizzo;
			return true;
		}
		if (copia2==null) {
			copia2=indirizzo;
			return true;
		}
		return false;
	} //fine addServer
	
	/**
	Restituisce il nome della stanza.
	*/
	protected String getNome() {
		return nome;
	} //fine getNome
	
	
} //fine classe

