package strutturedati;

import java.net.*;

/**
Autore:	Terenzio<BR>
Data:		01-09-2000<BR>
Vers:		1.0<BR>
Classe che contenere le informazioni relative a un utente collegato ad una stanza contenuta sul Server
di Chat. Si noti che l'utente potrebbe essere collegato alla copia.
*/

public class InfoUtente {
	private String nome;
	private InetAddress indirizzo;
	private int porta;
	private boolean collegato;

	//Costruttore
	
	public InfoUtente(String nome, InetAddress indirizzo, int porta, boolean collegato) {
		this.nome=nome;
		this.indirizzo=indirizzo;
		this.porta=porta;
		this.collegato=collegato;
	} //fine costruttore
	
	//Metodi
	
	/**
	Verifica se l' utente  collegato al Server di Chat o al Server che contiene la copia della stanza
	in cui l'utente stesso vuole entrare.
	*/
	protected boolean verifyCollegato() {
		return collegato;
	} //fine verifyCollegato
	
	/**
	Verifica se l'indirizzo dell'utente a cui si riferisce l'istanza e uguale a quello passato come 
	parametro. Ritorna true se l'indirizzo  lo stesso false altrimenti.
	*/
	protected boolean verifyIndirizzo(InetAddress indirizzoutente) {
		if (indirizzo.equals(indirizzoutente)) return true;
		return false;
	} //fine verifyIndirizzo
	
	/** 
	Setta il parametro collegato per l'utente. Collegato deve valere true se l'utente risulta collegato
	al server, false se l'utente risulta collegato al server contenente la copia della stanza.
	*/
	protected void setCollegato(boolean c) {
		collegato=c;
	} //fine setCollegato
	
	/** 
	Restituisce il nome dell' utente.
	*/
	protected String getNome() {
		return nome;
	} //fine getNome
	
	/**
	Restituisce l'indirizzo della macchina utilizzata dall' utente.
	*/
	protected InetAddress getIndirizzo() {
		return indirizzo;
	} //fine getIndirizzo
	
	/**
	Restituisce la porta UDP utilizzata dal client dell'utente per ricevere messaggi.
	*/
	protected int getPorta() {
		return porta;
	} //fine getPorta
	
	/**
	Restituisce l'indirizzo e la porta UDP utilizzate dal client dell'utente per ricevere messaggi.
	*/
	protected Receiver getReceiver() {
		return new Receiver(indirizzo, porta);
	} //fine getReceiver
	
		
} //fine classe

