package utilita;

/**
Autore:	Terenzio<BR>
Data:		01-09-2000<BR>
Vers:		1.0<BR>
Classe che contenere le costanti di comunicazione necessarie al Server di Chat.
*/

public final class CostantiCom {

	/**
	Codifica la richiesta di un Client ad un Server di Chat della lista delle stanze presenti nel sistema.
	*/
	public static final String ROOMREQC="ROOMREQC";
	/**
	Codifica la richiesta di un Client ad un Server di Chat di accesso ad una stanza nel sistema.
	*/
	public static final String ROOMACCC="ROOMACCC";
	/**
	Codifica la richiesta di un Server di Chat al Name Server Primario di ottenere la lista dei Server di
 	Chat presenti nel sistema.
	*/
	public static final String SCREQS="SCREQS";
	/**
	Codifica la richiesta di un Server di Chat al Name Server Primario di registrazione del Server.
	*/
	public static final String SCREGS="SCREGS";
	/**
	Codifica la richiesta di un Server di Chat al Name Server Primario di deregistrazione di un Server.
	*/
	public static final String SCDRGS="SCDRGS";
	/**
	Codifica la richiesta della lista delle stanze locali di un Server di Chat ad un altro Server di Chat.
	*/
	public static final String ROOMREQS="ROOMREQS";
	/**
	Codifica la richiesta di un Server di Chat ad un altro Server di Chat di creazione di una stanza.
	*/
	public static final String ROOMCRS="ROOMCRS";
	/**
	Codifica la richiesta di un Server di Chat ad un altro Server di Chat di accesso di un utente ad
 	una stanza gi esistente sul Server di Chat che riceve la richiesta.
	*/
	public static final String ROOMACCS="ROOMACCS";
  /**
	Codifica la richiesta di uscita di un utente da una stanza fatta da un Server di Chat ad un altro 
	Server di Chat contenente la stanza in cui l'utente si trova.
	*/
	public static final String USEREXIT="USEREXIT";
	/**
	Identifica il messaggio di testo standard inviato da un Server di Chat ad un Client in una stanza a
 	seguito dell' invio di un messaggio da parte di un utente.
	*/
	public static final String TESTO="TESTO";
	/**
	Identifica il messaggio di sistema inviato da un Server di Chat ad un Client in seguito alla 
	identificazione di una situazione di recovery per la stanza a cui il Client  connesso.
	*/
	public static final String SIST="SIST";
	/**
	Codifica la riuscita di una operazione.
	*/
	public static final String OK="OK";
	/**
	Codifica if fallimento di una operazione.
	*/
	public static final String FAIL="FAIL";
	/**
	Codifica l'avvenuta eliminazione di un utente da una stanza a seguito della richiesta fatta da un
	altro Server di Chat.
	*/
	public static final String USDEL="USDEL";
	/**
	Codifica l'avvenuta eliminazione di un utente e della stanza in cui l'utente si trovava a seguito 
	della richiesta fatta da un altro Server di Chat.
	*/
	public static final String USEROOMDEL="USEROOMDEL";
	
	/**
	Intero che codifica la lista vuota.<BR>
	Costante da inviare nelle seguenti situazioni:<BR>
	Dal Server di Chat verso il Client nela caso in cui la CacheStanze nel sistema non contenga nessuna 
	stanza<BR>
	Dal Server di Chat verso un altro Server di Chat nel caso in cui il DBStanzeLocali del primo server
	non contenga nessuna stanza.<BR>
	*/
	public static final int LISTAVUOTA=-1; 	
	
	
} //fine classe

